Unit AtariDbg;

Interface

Uses G320;

Type
  PBankSwitch = ^TBankSwitch;
  TBankSwitch = Array[0..8192] Of Byte;

Const
  HiRes : Boolean = False;

Var
  FontSmPtr : Pointer;

Function Debug(Buf: Pointer; Var PC: Word; Var P,A,X,Y,S: Byte; Scan,Count,Bank: Integer;
               ScnAddr: LongInt; Var NewStart: Word;{ Var OldByte: Byte;}
               BS: PBankSwitch; ROMBackup,TIA_Regs,Input_Byte,ObjectLoc: Pointer;
               Use160By200: Boolean; Var HaltLine: Integer): Boolean;

Function  ToUpper(St: String): String;
Function  Exist(FileName: String): Boolean;
Procedure Set160Cols;
Procedure Set320Cols;
Procedure Set200Rows;
Procedure Set205Rows;
Procedure Set210Rows;
Procedure Set215Rows;
Procedure Set240Rows;

Procedure SetRows(Rows: Word);
Procedure Set160Rows(Rows: Word);

Implementation

Uses OPCrt,Dos,HexWrite,ModeX,Vectors,AtariDis;

Const
  VSYNC   = 0;
  VBLANK  = 1;
  WSYNC   = 2;
  RSYNC   = 3;
  NUSIZ0  = 4;
  NUSIZ1  = 5;
  COLUP0  = 6;
  COLUP1  = 7;
  COLUPF  = 8;
  COLUBK  = 9;
  CTRLPF  = $0A;
  REFP0   = $0B;
  REFP1   = $0C;
  PF0     = $0D;
  PF1     = $0E;
  PF2     = $0F;
  RESP0   = $10;
  RESP1   = $11;
  RESM0   = $12;
  RESM1   = $13;
  RESBL   = $14;
  AUDC0   = $15;
  AUDC1   = $16;
  AUDF0   = $17;
  AUDF1   = $18;
  AUDV0   = $19;
  AUDV1   = $1A;
  GRP0    = $1B;
  GRP1    = $1C;
  ENAM0   = $1D;
  ENAM1   = $1E;
  ENABL   = $1F;
  HMP0    = $20;
  HMP1    = $21;
  HMM0    = $22;
  HMM1    = $23;
  HMBL    = $24;
  VDELP0  = $25;
  VDELP1  = $26;
  VDELBL  = $27;
  RESMP0  = $28;
  RESMP1  = $29;
  HMOVE   = $2A;
  HMCLR   = $2B;
  CXCLR   = $2C;
  SWCHA1  = $280;
  SWACNT1 = $281;
  SWCHB1  = $282;
  SWBCNT1 = $283;
  INTTIM1 = $284;
  INTTIM3 = $285;
  TIM1T1  = $294;
  TIM2T1  = $295;
  TIM3T1  = $296;
  TIM4T1  = $297;
  SWCHA2  = $380;
  SWACNT2 = $381;
  SWCHB2  = $382;
  SWBCNT2 = $383;
  INTTIM2 = $384;
  TIM1T2  = $394;
  TIM2T2  = $395;
  TIM3T2  = $396;
  TIM4T2  = $397;

  Player0Set  = 2;
  Player1Set  = 4;
  Missile0Set = 8;
  Missile1Set = 16;
  BallSet     = 32;

  _32BIT_OPERAND = $66;
(*
  TIA_Name : Array[0..$2C] Of String[6] =
   ('VSYNC' ,'VBLANK','WSYNC' ,'RSYNC' ,'NUSIZ0','NUSIZ1','COLUP0','COLUP1',
    'COLUPF','COLUBK','CTRLPF','REFP0' ,'REFP1' ,'PF0'   ,'PF1'   ,'PF2',
    'RESP0' ,'RESP1' ,'RESM0' ,'RESM1' ,'RESBL' ,'AUDC0' ,'AUDC1' ,'AUDF0',
    'AUDF1' ,'AUDV0' ,'AUDV1' ,'GRP0'  ,'GRP1'  ,'ENAM0' ,'ENAM1' ,'ENABL' ,
    'HMP0'  ,'HMP1'  ,'HMM0'  ,'HMM1'  ,'HMBL'  ,'VDELP0','VDELP1','VDELBL',
    'RESMP0','RESMP1','HMOVE' ,'HMCLR' ,'CXCLR');

  PIA_Name : Array[$280..$297] Of String[8] =
   ('SWCHA','SWACNT','SWCHB','SWBCNT','INTTIM','INTRPT','','','','','','','','',
    '','','','','','','TIM1T','TIM8T','TIM64T','TIM1024T');

  TIA_Read_Name : Array[0..$D] Of String[6] =
   ('CXM0P' ,'CXM1P', 'CXP0FB','CXP1FB','CXM0FB','CXM1FB','CXBLPF','CXPPMM',
    'INPUT0','INPUT1','INPUT2','INPUT3','INPUT4','INPUT5');
  Bytes : Array[0..255] Of Word =
   (1,2,1,2,2,2,2,2, 1,2,1,2,3,3,3,3,  { 00-0F }
    2,2,1,2,2,2,2,2, 1,3,1,3,3,3,3,3,  { 10-1F }
    3,2,1,2,2,2,2,2, 1,2,1,2,3,3,3,3,  { 20-2F }
    2,2,1,2,2,2,2,2, 1,3,1,3,3,3,3,3,  { 30-3F }
    1,2,1,2,2,2,2,2, 1,2,1,2,3,3,3,3,  { 40-4F }
    2,2,1,2,2,2,2,2, 1,3,1,3,3,3,3,3,  { 50-5F }
    1,2,1,2,2,2,2,2, 1,2,1,1,3,3,3,3,  { 60-6F }
    2,2,1,2,2,2,2,2, 1,3,1,3,3,3,3,3,  { 70-7F }
    2,2,2,2,2,2,2,2, 1,1,1,2,3,3,3,3,  { 80-8F }
    2,2,1,2,2,2,2,2, 1,3,1,3,3,3,3,3,  { 90-9F }
    2,2,2,2,2,2,2,1, 1,2,1,1,3,3,3,3,  { A0-AF }
    2,2,1,2,2,2,2,2, 1,3,1,3,3,3,3,3,  { B0-BF }
    2,2,2,1,2,2,2,2, 1,2,1,2,3,3,3,3,  { C0-CF }
    2,2,1,2,2,2,2,2, 1,3,1,3,3,3,3,3,  { D0-DF }
    2,2,2,1,2,2,2,1, 1,2,1,2,3,3,3,3,  { E0-EF }
    2,2,1,1,2,2,2,1, 1,3,1,1,3,3,3,1); { F0-FF }

  Mnem : Array[0..255] Of String[3] =
   ('BRK','ORA','   ','slo','skb','ORA','ASL','slo',   { 00-07 }
    'PHP','ORA','ASL','anc','skw','ORA','ASL','slo',   { 08-0F }
    'BPL','ORA','   ','slo','skb','ORA','ASL','slo',   { 10-17 }
    'CLC','ORA','NOP','slo','skw','ORA','ASL','slo',   { 18-1F }
    'JSR','AND','   ','rla','BIT','AND','ROL','rla',   { 20-27 }
    'PLP','AND','ROL','anc','BIT','AND','ROL','rla',   { 28-2F }
    'BMI','AND','   ','rla','skb','AND','ROL','rla',   { 30-37 }
    'SEC','AND','NOP','rla','skw','AND','ROL','rla',   { 38-3F }
    'RTI','EOR','   ','sre','skb','EOR','LSR','sre',   { 40-47 }
    'PHA','EOR','LSR','asr','JMP','EOR','LSR','sre',   { 48-4F }
    'BVC','EOR','   ','sre','skb','EOR','LSR','sre',   { 50-57 }
    'CLI','EOR','IMP','sre','skw','EOR','LSR','sre',   { 58-5F }
    'RTS','ADC','   ','rra','skb','ADC','ROR','rra',   { 60-67 }
    'PLA','ADC','ROR','   ','JMP','ADC','ROR','rra',   { 68-6F }
    'BVS','ADC','   ','rra','skb','ADC','ROR','rra',   { 70-77 }
    'SEI','ADC','NOP','rra','skw','ADC','ROR','rra',   { 78-7F }
    'skb','STA','skb','sax','STY','STA','STX','sax',   { 80-87 }
    'DEY','NOP','TXA','ane','STY','STA','STX','sax',   { 88-8F }
    'BCC','STA','   ','sha','STY','STA','STX','sax',   { 90-97 }
    'TYA','STA','TXS','shs','shy','STA','shx','sha',   { 98-9F }
    'LDY','LDA','LDX','lax','LDY','LDA','LDX','lax',   { A0-A7 }
    'TAY','LDA','TAX','lxa','LDY','LDA','LDX','lax',   { A8-AF }
    'BCS','LDA','   ','lax','LDY','LDA','LDX','lax',   { B0-B7 }
    'CLV','LDA','TSX','las','LDY','LDA','LDX','lax',   { B8-BF }
    'CPY','CMP','skb','dcp','CPY','CMP','DEC','dcp',   { C0-C7 }
    'INY','CMP','DEX','sbx','CPY','CMP','DEC','dcp',   { C8-CF }
    'BNE','CMP','   ','dcp','skb','CMP','DEC','dcp',   { D0-D7 }
    'CLD','CMP','NOP','dcp','skw','CMP','DEC','dcp',   { D8-DF }
    'CPX','SBC','skb','   ','CPX','SBC','INC','   ',   { E0-E7 }
    'INX','SBC','NOP','SBC','CPX','SBC','INC','   ',   { E8-EF }
    'BEQ','SBC','   ','   ','skb','SBC','INC','   ',   { F0-F7 }
    'SED','SBC','NOP','   ','skw','SBC','INC','   ');  { F8-FF }

  ATyp : Array[0..255] Of String[3] =
   ('IMP','I.X','   ','I.X','IMP','Z.P','Z.P','Z.P',   { 00-07 }
    'IMP','IMM','ACC','IMM','IMP','ABS','ABS','ABS',   { 08-0F }
    'REL','I.Y','   ','I.Y','IMP','Z.X','Z.X','Z.X',   { 10-17 }
    'IMP','A.Y','IMP','A.Y','IMP','A.X','A.X','A.X',   { 18-1F }
    'ABS','I.X','   ','I.X','Z.P','Z.P','Z.P','Z.P',   { 20-27 }
    'IMP','IMM','ACC','IMM','ABS','ABS','ABS','ABS',   { 28-2F }
    'REL','I.Y','   ','I.Y','IMP','Z.X','Z.X','Z.X',   { 30-37 }
    'IMP','A.Y','IMP','A.Y','IMP','A.X','A.X','A.X',   { 38-3F }
    'IMP','I.X','   ','I.X','IMP','Z.P','Z.P','Z.P',   { 40-47 }
    'IMP','IMM','ACC','IMM','ABS','ABS','ABS','ABS',   { 48-4F }
    'REL','I.Y','   ','I.Y','IMP','Z.X','Z.X','Z.X',   { 50-57 }
    'IMP','A.Y','IMP','A.Y','IMP','A.X','A.X','A.X',   { 58-5F }
    'IMP','I.X','   ','I.X','IMP','Z.P','Z.P','Z.P',   { 60-67 }
    'IMP','IMM','ACC','   ','IND','ABS','ABS','ABS',   { 68-6F }
    'REL','I.Y','   ','I.Y','IMP','Z.X','Z.X','Z.X',   { 70-77 }
    'IMP','A.Y','IMP','A.Y','IMP','A.X','A.X','A.X',   { 78-7F }
    'IMP','I.X','IMP','I.X','Z.P','Z.P','Z.P','Z.P',   { 80-87 }
    'IMP','IMP','IMP','IMM','ABS','ABS','ABS','ABS',   { 88-8F }
    'REL','I.Y','   ','I.Y','Z.X','Z.X','Z.Y','Z.Y',   { 90-97 }
    'IMP','A.Y','IMP','I.Y','A.X','A.X','A.Y','A.Y',   { 98-9F }
    'IMM','I.X','IMM','I.X','Z.P','Z.P','Z.P','Z.P',   { A0-A7 }
    'IMP','IMM','IMP','I+A','ABS','ABS','ABS','ABS',   { A8-AF }
    'REL','I.Y','   ','I.Y','Z.X','Z.X','Z.Y','Z.Y',   { B0-B7 }
    'IMP','A.Y','IMP','ASY','A.X','A.X','A.Y','A.Y',   { B8-BF }
    'IMM','I.X','IMP','I.X','Z.P','Z.P','Z.P','Z.P',   { C0-C7 }
    'IMP','IMM','IMP','IMM','ABS','ABS','ABS','ABS',   { C8-CF }
    'REL','I.Y','   ','I.Y','IMP','Z.X','Z.X','Z.X',   { D0-D7 }
    'IMP','A.Y','IMP','A.Y','IMP','A.X','A.X','A.X',   { D8-DF }
    'IMM','I.X','IMP','   ','Z.P','Z.P','Z.P','   ',   { E0-E7 }
    'IMP','IMM','IMP','IMM','ABS','ABS','ABS','   ',   { E8-EF }
    'REL','I.Y','   ','   ','IMP','Z.X','Z.X','   ',   { F0-F7 }
    'IMP','A.Y','IMP','   ','IMP','A.X','A.Y','   ');  { F8-FF }
*)
Const
  NormTextColor = 0;
  HiTextColor   = 31;
  PCTextColor   = 246;
  LineColor     = 14;
  TextStart     = 2;
  TextHeight    = 8;
  BackColor     = 4;
  DisasmColor   = 174;
  FlagsColor    = 250;{254;}
  RegsColor     = 108;{110;}
  DataColor     = 158;
  ScrDatColor   = 90;
  TIA_Color     = 155;
  TextBGColor   = 149;
  PopupColor    = 10;
  DisasmLines   = 16;
  HRDisasmLines = 32;
  DataLines     = 8;
  SmFontSize    = 1024;

Var
  Win         : _WindowPtr;
  HelpWin     : _WindowPtr;
  OldExitProc : Pointer;
  LineWinData : Pointer;

Function ToUpper(St: String): String;
Var I: Byte;
Begin
  If St = '' Then
  Begin
    ToUpper := '';
    Exit;
  End;
  For I := 1 To Length(St) Do St[I] := UpCase(St[I]);
  ToUpper := St;
End; { ToUpper }


Function ValHex(St: String): LongInt;
Var
  Initial : LongInt;
  I       : Integer;
  Value   : LongInt;

Begin
  If St = '' Then
  Begin
    ValHex := -1;
    Exit;
  End;
{  If Length(St) > 8 Then St := Copy(St,1,8);}
  Value   := 0;
  St      := ToUpper(St);
  I       := (Length(St) - 1) * 4;
  Asm
    DB    _32BIT_OPERAND
    SUB   AX,AX
    MOV   AX,1
    MOV   CX,WORD PTR I
    DB    _32BIT_OPERAND
    SHL   AX,CL
    DB    _32BIT_OPERAND
    MOV   WORD PTR Initial,AX
  End; { Asm }
  For I := 1 To Length(St) Do
  Begin
    If St[I] In ['0'..'9'] Then Inc(Value,Initial * (Ord(St[I]) - Ord('0')))
     Else
      If St[I] In ['A'..'F'] Then Inc(Value,Initial * (Ord(St[I]) - Ord('A') + 10))
       Else
       Begin
         ValHex := -1;
         Exit;
       End;
    Initial := Initial Shr 4;
  End; { For I }
  ValHex := Value;
End; { ValHex }


Function NoSpace(St: String): String;
Begin
  While (St <> '') And (St[1]          = ' ') Do St := Copy(St,2,Length(St) - 1);
  While (St <> '') And (St[Length(St)] = ' ') Do St := Copy(St,1,Length(St) - 1);
  NoSpace := St;
End; { NoSpace }


Function Exist(FileName: String): Boolean;
Var Fil: File;
Begin
  Assign(Fil,FileName);
  {$I-}
  Reset(Fil);
  {$I+}
  If (IOResult = 0) Then
  Begin
    Close(Fil);
    Exist := True;
  End
  Else Exist := False;
End; { Exist }


{$F+}
Procedure NewExitProc;
Begin
  FreeMem(FontSmPtr,SmFontSize);
End; { NewExitProc }
{$F-}


Procedure LoadSmallFont;
Var F: File;
Begin
  Assign(F,'PCAE.FNT');
  Reset(F,1);
  BlockRead(F,FontSmPtr^,SmFontSize);
  Close(F);
End; { LoadSmallFont }


Const
  VGA_SEGMENT   = $A000;
  SC_INDEX      = $3C4;   { Sequence Controller Index register   }
  GC_INDEX      = $3CE;   { Graphics Controller Index register   }
  CRTC_INDEX    = $3D4;   { CRT Controller Index register        }
  MISC_OUTPUT   = $3C2;   { Miscellaneous Output Register        }
  MISCELLANEOUS = 6;      { Moscellaneous register index in GC   }
  MEMORY_MODE   = 4;      { Memory Mode register index in SC     }
  GRAPHICS_MODE = 5;      { Graphics Mode register index in GC   }
  MAX_SCAN_LINE = 9;      { Maximum Scan Line reg index in CRTC  }
  UNDERLINE     = $14;    { Underline Location reg index in CRTC }
  MODE_CONTROL  = $17;    { Mode Control register index in CRTC  }
  MAP_MASK      = 2;      { Map Mask register index in SC        }

  HORZ_TOTAL         = 0;
  HORZ_DISPLAY_END   = 1;
  START_HORZ_BLANK   = 2;
  END_HORZ_BLANK     = 3;
  START_HORZ_RETRACE = 4;
  END_HORZ_RETRACE   = 5;
  VERT_TOTAL         = 6;
  OVERFLOW           = 7;
  START_VERT_RETRACE = $10;
  END_VERT_RETRACE   = $11;
  VERT_DISPLAY_END   = $12;
  CRTC_OFFSET        = $13;
  START_VERT_BLANK   = $15;
  END_VERT_BLANK     = $16;
  LINE_COMPARE       = $18;

Procedure Set320By200Mode; Assembler;
Asm
  MOV   DX,SC_INDEX
  MOV   AL,MEMORY_MODE
  OUT   DX,AL
  INC   DX
  IN    AL,DX
  OR    AL,08h                    { Turn on chain 4 }
  AND   AL,NOT 04h                { Turn on odd/even }
  OUT   DX,AL
  MOV   DX,GC_INDEX
  MOV   AL,GRAPHICS_MODE
  OUT   DX,AL
  INC   DX
  IN    AL,DX
  OR    AL,10h                    { Turn on odd/even }
  OUT   DX,AL
  DEC   DX
  MOV   AL,MISCELLANEOUS
  OUT   DX,AL
  INC   DX
  IN    AL,DX
  OR    AL,02h                    { Turn on chain }
  OUT   DX,AL

  { Now clear the whole screen.  Do this before we switch the CRTC out }
  { of mode 13h, so we don't see garbage on the screen when we make    }
  { the switch.                                                        }

  MOV   DX,SC_INDEX               { Enable writes to all planes, so  }
  MOV   AX,0F00h + MAP_MASK       {  we can clear 4 pixels at a time }
  OUT   DX,AX
  MOV   AX,VGA_SEGMENT
  MOV   ES,AX
  SUB   DI,DI
  MOV   AX,DI
  MOV   CX,8000h                  { # of words in 64k }
  CLD
  REP   STOSW

  MOV   DX,CRTC_INDEX
  MOV   AL,MAX_SCAN_LINE
  OUT   DX,AL
  INC   DX
  IN    AL,DX
  OR    AL,1                      { Set maximum scan line = 1 }
  OUT   DX,AL
  DEC   DX

  MOV   AL,UNDERLINE
  OUT   DX,AL
  INC   DX
  IN    AL,DX
  OR    AL,40h                    { Turn on doubleword }
  OUT   DX,AL
  DEC   DX
  MOV   AL,MODE_CONTROL
  OUT   DX,AL
  INC   DX
  IN    AL,DX
  AND   AL,NOT 40h
  OUT   DX,AL
End; { Set320By200Mode }


Procedure Set320By400Mode; Assembler;
Asm

  { Change CPU addressing of video memory to linear (not odd/even,     }
  { chain, or chain 4), to allow us to access all 256K of display      }
  { memory.  When this is done, VGA memory will look just like memory  }
  { in modes 10h and 12h, except that each byte of display memory will }
  { control one 256-color pixel, with 4 adjacent pixels at any given   }
  { address, one pixel per plane.                                      }

  MOV   DX,SC_INDEX
  MOV   AL,MEMORY_MODE
  OUT   DX,AL
  INC   DX
  IN    AL,DX
  AND   AL,NOT 08h                { Turn off chain 4 }
  OR    AL,04h                    { Turn off odd/even }
  OUT   DX,AL
  MOV   DX,GC_INDEX
  MOV   AL,GRAPHICS_MODE
  OUT   DX,AL
  INC   DX
  IN    AL,DX
  AND   AL,NOT 10h                { Turn off odd/even }
  OUT   DX,AL
  DEC   DX
  MOV   AL,MISCELLANEOUS
  OUT   DX,AL
  INC   DX
  IN    AL,DX
  AND   AL,NOT 02h                { Turn off chain }
  OUT   DX,AL

  { Now clear the whole screen.  Do this before we switch the CRTC out }
  { of mode 13h, so we don't see garbage on the screen when we make    }
  { the switch.                                                        }

  MOV   DX,SC_INDEX               { Enable writes to all planes, so  }
  MOV   AX,0F00h + MAP_MASK       {  we can clear 4 pixels at a time }
  OUT   DX,AX
  MOV   AX,VGA_SEGMENT
  MOV   ES,AX
  SUB   DI,DI
  MOV   AX,DI
  MOV   CX,8000h                  { # of words in 64k }
  CLD
  REP   STOSW

  { Tweak the mode to 320x400 256-color mode by not scanning each line }
  { twice.                                                             }

  MOV   DX,CRTC_INDEX
  MOV   AL,MAX_SCAN_LINE
  OUT   DX,AL
  INC   DX
  IN    AL,DX
  AND   AL,NOT 1Fh                { Set maximum scan line = 0 }
  OUT   DX,AL
  DEC   DX

  { Change CRTC scanning from doubleword mode to byte mode, allowing }
  { the CRTC to scan more than 64K of video data.                    }

  MOV   AL,UNDERLINE
  OUT   DX,AL
  INC   DX
  IN    AL,DX
  AND   AL,NOT 40h                { Turn off doubleword }
  OUT   DX,AL
  DEC   DX
  MOV   AL,MODE_CONTROL
  OUT   DX,AL
  INC   DX
  IN    AL,DX
  OR    AL,40h                    { Turn on the byte mode bit, so memory   }
  OUT   DX,AL                     {  is scanned for video data in a purely }
                                  {  linear way, just as in modes 10h and  }
                                  {  12h                                   }
End; { Set320By400Mode }


Procedure UnprotectCRTC; Assembler;
Asm

  { Un-protect the CRTC registers }

  MOV   DX,CRTC_INDEX
  MOV   AL,END_VERT_RETRACE
  OUT   DX,AL
  INC   DX
  IN    AL,DX
  AND   AL,7Fh
  OUT   DX,AL
  DEC   DX
  MOV   AL,END_HORZ_BLANK
  OUT   DX,AL
  IN    AL,DX
  OR    AL,80h
  OUT   DX,AL
End; { UnprotectCRTC }


Procedure ProtectCRTC; Assembler;
Asm

  { Re-protect the CRTC registers }

  MOV   DX,CRTC_INDEX
  MOV   AL,END_HORZ_BLANK
  OUT   DX,AL
  INC   DX
  IN    AL,DX
  AND   AL,7Fh
  OUT   DX,AL
  DEC   DX
  MOV   AL,END_VERT_RETRACE
  OUT   DX,AL
  IN    AL,DX
  OR    AL,80h
  OUT   DX,AL
End; { ProtectCRTC }


Procedure Set160Cols;
Begin
  UnprotectCRTC;
  Asm

    { Change to 160 columns by changing the horizontal registers }

    MOV   DX,SC_INDEX

    MOV   AL,1
    OUT   DX,AL
    INC   DX
    IN    AL,DX
    OR    AL,8
    OUT   DX,AL

    MOV   DX,CRTC_INDEX

    MOV   AL,HORZ_TOTAL
    OUT   DX,AL
    INC   DX
    MOV   AL,2Ah
    OUT   DX,AL
    DEC   DX

    MOV   AL,HORZ_DISPLAY_END
    OUT   DX,AL
    INC   DX
    MOV   AL,27h
    OUT   DX,AL
    DEC   DX

    MOV   AL,START_HORZ_BLANK
    OUT   DX,AL
    INC   DX
    MOV   AL,28h
    OUT   DX,AL
    DEC   DX

    MOV   AL,END_HORZ_BLANK
    OUT   DX,AL
    INC   DX
    MOV   AL,8Eh
    OUT   DX,AL
    DEC   DX

    MOV   AL,START_HORZ_RETRACE
    OUT   DX,AL
    INC   DX
    MOV   AL,2Ch
    OUT   DX,AL
    DEC   DX

    MOV   AL,END_HORZ_RETRACE
    OUT   DX,AL
    INC   DX
    MOV   AL,8Eh
    OUT   DX,AL
    DEC   DX

    MOV   AL,CRTC_OFFSET
    OUT   DX,AL
    INC   DX
    MOV   AL,14h
    OUT   DX,AL
    DEC   DX
  End; { Asm }
  ProtectCRTC;
End; { Set160Cols }


Procedure Set320Cols;
Begin
  UnprotectCRTC;
  Asm

    { Change to 320 columns by changing the horizontal registers }

    MOV   DX,CRTC_INDEX

    MOV   AL,HORZ_TOTAL
    OUT   DX,AL
    INC   DX
    MOV   AL,5Fh
    OUT   DX,AL
    DEC   DX

    MOV   AL,HORZ_DISPLAY_END
    OUT   DX,AL
    INC   DX
    MOV   AL,4Fh
    OUT   DX,AL
    DEC   DX

    MOV   AL,START_HORZ_BLANK
    OUT   DX,AL
    INC   DX
    MOV   AL,50h
    OUT   DX,AL
    DEC   DX

    MOV   AL,END_HORZ_BLANK
    OUT   DX,AL
    INC   DX
    MOV   AL,82h
    OUT   DX,AL
    DEC   DX

    MOV   AL,START_HORZ_RETRACE
    OUT   DX,AL
    INC   DX
    MOV   AL,24h
    OUT   DX,AL
    DEC   DX

    MOV   AL,END_HORZ_RETRACE
    OUT   DX,AL
    INC   DX
    MOV   AL,80h
    OUT   DX,AL
    DEC   DX

    MOV   AL,CRTC_OFFSET
    OUT   DX,AL
    INC   DX
    MOV   AL,28h
    OUT   DX,AL
    DEC   DX
  End; { Asm }
  ProtectCRTC;
End; { Set320Cols }


Procedure SetRows(Rows: Word);
Begin
  UnprotectCRTC;
  Asm

    { Change to new rows by changing the vertical registers }

    MOV   BX,WORD PTR Rows
    SUB   BX,200

    MOV   DX,CRTC_INDEX

    MOV   AL,MAX_SCAN_LINE
    OUT   DX,AL
    INC   DX
    IN    AL,DX
    MOV   CL,AL
    AND   CL,1Fh
    SHL   BX,CL
    DEC   DX

    MOV   AL,VERT_TOTAL
    OUT   DX,AL
    INC   DX
    IN    AL,DX
    ADD   AL,BL
    OUT   DX,AL
    DEC   DX
{
    MOV   AL,OVERFLOW
    OUT   DX,AL
    INC   DX
    MOV   AL,1Fh
    OUT   DX,AL
    DEC   DX

    MOV   AL,MAX_SCAN_LINE
    OUT   DX,AL
    INC   DX
    MOV   AL,41h
    OUT   DX,AL
    DEC   DX
}
    MOV   AL,START_VERT_RETRACE
    OUT   DX,AL
    INC   DX
    IN    AL,DX
    ADD   AL,BL
    OUT   DX,AL
    DEC   DX

    MOV   AL,END_VERT_RETRACE
    OUT   DX,AL
    INC   DX
    IN    AL,DX
    MOV   CL,AL
    ADD   CL,BL
    AND   CL,0Fh
    AND   AL,20h
    OR    AL,CL
    OUT   DX,AL
    DEC   DX

    MOV   AL,VERT_DISPLAY_END
    OUT   DX,AL
    INC   DX
    IN    AL,DX
    ADD   AL,BL
    OUT   DX,AL
    DEC   DX

    MOV   AL,START_VERT_BLANK
    OUT   DX,AL
    INC   DX
    IN    AL,DX
    ADD   AL,BL
    OUT   DX,AL
    DEC   DX

    MOV   AL,END_VERT_BLANK
    OUT   DX,AL
    INC   DX
    IN    AL,DX
    ADD   AL,BL
    OUT   DX,AL
    DEC   DX
  End; { Asm }
  ProtectCRTC;
End; { SetRows }


Procedure Set160Rows(Rows: Word);
Var
  MSL,OV,VT,SVR,EVR,VDE,SVB,EVB,LC : Word;

Begin
  UnprotectCRTC;
  Asm

    { Change to 160 columns by changing the horizontal registers }

    MOV   DX,SC_INDEX

    MOV   AL,1
    OUT   DX,AL
    INC   DX
    IN    AL,DX
    OR    AL,8
    OUT   DX,AL

    MOV   DX,CRTC_INDEX

    MOV   AL,HORZ_TOTAL
    OUT   DX,AL
    INC   DX
    MOV   AL,2Ah
    OUT   DX,AL
    DEC   DX

    MOV   AL,HORZ_DISPLAY_END
    OUT   DX,AL
    INC   DX
    MOV   AL,27h
    OUT   DX,AL
    DEC   DX

    MOV   AL,START_HORZ_BLANK
    OUT   DX,AL
    INC   DX
    MOV   AL,28h
    OUT   DX,AL
    DEC   DX

    MOV   AL,END_HORZ_BLANK
    OUT   DX,AL
    INC   DX
    MOV   AL,8Eh
    OUT   DX,AL
    DEC   DX

    MOV   AL,START_HORZ_RETRACE
    OUT   DX,AL
    INC   DX
    MOV   AL,2Ch
    OUT   DX,AL
    DEC   DX

    MOV   AL,END_HORZ_RETRACE
    OUT   DX,AL
    INC   DX
    MOV   AL,8Eh
    OUT   DX,AL
    DEC   DX

    MOV   AL,CRTC_OFFSET
    OUT   DX,AL
    INC   DX
    MOV   AL,14h
    OUT   DX,AL
    DEC   DX

    { Get rows info }

    MOV   DX,CRTC_INDEX

    MOV   AL,MAX_SCAN_LINE
    OUT   DX,AL
    INC   DX
    IN    AL,DX
    MOV   BYTE PTR MSL,AL
    DEC   DX

    MOV   AL,VERT_TOTAL
    OUT   DX,AL
    INC   DX
    IN    AL,DX
    MOV   BYTE PTR VT,AL
    DEC   DX

    MOV   AL,OVERFLOW
    OUT   DX,AL
    INC   DX
    IN    AL,DX
    MOV   BYTE PTR OV,AL
    MOV   BYTE PTR OV[1],AL
    DEC   DX

    MOV   AL,START_VERT_RETRACE
    OUT   DX,AL
    INC   DX
    IN    AL,DX
    MOV   BYTE PTR SVR,AL
    DEC   DX

    MOV   AL,END_VERT_RETRACE
    OUT   DX,AL
    INC   DX
    IN    AL,DX
    MOV   BYTE PTR EVR,AL
    DEC   DX

    MOV   AL,VERT_DISPLAY_END
    OUT   DX,AL
    INC   DX
    IN    AL,DX
    MOV   BYTE PTR VDE,AL
    DEC   DX

    MOV   AL,START_VERT_BLANK
    OUT   DX,AL
    INC   DX
    IN    AL,DX
    MOV   BYTE PTR SVB,AL
    DEC   DX

    MOV   AL,END_VERT_BLANK
    OUT   DX,AL
    INC   DX
    IN    AL,DX
    MOV   BYTE PTR EVB,AL
    DEC   DX

    MOV   AL,LINE_COMPARE
    OUT   DX,AL
    INC   DX
    IN    AL,DX
    MOV   BYTE PTR LC,AL
    DEC   DX

    { Form 16-bit vertical values }

    MOV   AL,BYTE PTR OV
    MOV   AH,AL
    AND   AX,2001h
    SHR   AH,4
    OR    AL,AH
    MOV   BYTE PTR VT[1],AL

    MOV   AL,BYTE PTR OV
    MOV   AH,AL
    AND   AX,4002h
    SHR   AH,4
    OR    AL,AH
    SHR   AL,1
    MOV   BYTE PTR VDE[1],AL

    MOV   AL,BYTE PTR OV
    MOV   AH,AL
    AND   AX,8004h
    SHR   AH,4
    OR    AL,AH
    SHR   AL,2
    MOV   BYTE PTR SVR[1],AL

    MOV   AL,BYTE PTR OV
    AND   AL,8
    MOV   AH,BYTE PTR MSL
    AND   AH,20h
    SHR   AH,1
    OR    AL,AH
    SHR   AL,3
    MOV   BYTE PTR SVB[1],AL

    MOV   AL,BYTE PTR OV
    AND   AL,10h
    MOV   AH,BYTE PTR MSL
    AND   AH,40h
    SHR   AH,1
    OR    AL,AH
    SHR   AL,4
    MOV   BYTE PTR LC[1],AL

    MOV   AX,WORD PTR SVR
    AND   AX,3F0h
    MOV   BL,BYTE PTR EVR
    AND   BL,0Fh
    OR    AL,BL
    CMP   AX,WORD PTR SVR
    JGE   @L1
    ADD   AX,10h
@L1:
    MOV   WORD PTR EVR,AX

    MOV   AH,BYTE PTR SVB[1]
    MOV   AL,BYTE PTR EVB
    CMP   AX,WORD PTR SVB
    JGE   @L2
    INC   AH
@L2:
    MOV   BYTE PTR EVB[1],AH

    { Get the increment }

    MOV   BX,WORD PTR Rows
    SUB   BX,200
    MOV   CL,BYTE PTR MSL
    AND   CL,1Fh
    SHL   BX,CL

    { Add the increment }

    ADD   WORD PTR VT,BX
    ADD   WORD PTR SVR,BX
    ADD   WORD PTR EVR,BX
    ADD   WORD PTR VDE,BX
    ADD   WORD PTR SVB,BX
    ADD   WORD PTR EVB,BX
    ADD   WORD PTR LC,BX

    { Bounds-checking }

    CMP   WORD PTR LC,3FFh
    JLE   @L3
    MOV   WORD PTR LC,3FFh
@L3:

    { Form the new overflow }

    MOV   AL,BYTE PTR VT[1]
    MOV   AH,AL
    SHL   AH,4
    AND   AX,2001h
    OR    AL,AH

    MOV   BL,BYTE PTR VDE[1]
    MOV   BH,BL
    SHL   BH,4
    AND   BX,2001h
    SHL   BX,1
    OR    AL,BL
    OR    AL,BH

    MOV   BL,BYTE PTR SVR[1]
    MOV   BH,BL
    SHL   BH,4
    AND   BX,2001h
    SHL   BX,2
    OR    AL,BL
    OR    AL,BH

    MOV   BL,BYTE PTR SVB[1]
    AND   BL,1
    SHL   BL,3
    OR    AL,BL

    MOV   BL,BYTE PTR LC[1]
    AND   BL,1
    SHL   BL,4
    OR    AL,BL

    MOV   BYTE PTR OV,AL

    { Form the new max scan line }

    MOV   AL,BYTE PTR MSL
    AND   AL,9Fh

    MOV   BL,BYTE PTR SVB[1]
    AND   BL,2
    SHL   BL,4
    OR    AL,BL

    MOV   BL,BYTE PTR LC[1]
    AND   BL,2
    SHL   BL,5
    OR    AL,BL

    MOV   BYTE PTR MSL,AL

    { Output the new values }

    MOV   AL,MAX_SCAN_LINE
    OUT   DX,AL
    INC   DX
    MOV   AL,BYTE PTR MSL
    OUT   DX,AL
    DEC   DX

    MOV   AL,VERT_TOTAL
    OUT   DX,AL
    INC   DX
    MOV   AL,BYTE PTR VT
    OUT   DX,AL
    DEC   DX

    MOV   AL,OVERFLOW
    OUT   DX,AL
    INC   DX
    MOV   AL,BYTE PTR OV
    OUT   DX,AL
    DEC   DX

    MOV   AL,START_VERT_RETRACE
    OUT   DX,AL
    INC   DX
    MOV   AL,BYTE PTR SVR
    OUT   DX,AL
    DEC   DX

    MOV   AL,END_VERT_RETRACE
    OUT   DX,AL
    INC   DX
    IN    AL,DX
    AND   AL,0F0h
    MOV   AH,BYTE PTR EVR
    AND   AH,0Fh
    OR    AL,AH
    OUT   DX,AL
    DEC   DX

    MOV   AL,VERT_DISPLAY_END
    OUT   DX,AL
    INC   DX
    MOV   AL,BYTE PTR VDE
    OUT   DX,AL
    DEC   DX

    MOV   AL,START_VERT_BLANK
    OUT   DX,AL
    INC   DX
    MOV   AL,BYTE PTR SVB
    OUT   DX,AL
    DEC   DX

    MOV   AL,END_VERT_BLANK
    OUT   DX,AL
    INC   DX
    MOV   AL,BYTE PTR EVB
    OUT   DX,AL
    DEC   DX

    MOV   AL,LINE_COMPARE
    OUT   DX,AL
    INC   DX
    MOV   AL,BYTE PTR LC
    OUT   DX,AL
    DEC   DX
  End; { Asm }
  ProtectCRTC;
{
  TextMode(C80);
  WriteLn('MSL = ',HexWord(MSL));
  WriteLn('OV  = ',HexWord(OV));
  WriteLn('VT  = ',HexWord(VT));
  WriteLn('VDE = ',HexWord(VDE));
  WriteLn('SVB = ',HexWord(SVB));
  WriteLn('EVB = ',HexWord(EVB));
  WriteLn('SVR = ',HexWord(SVR));
  WriteLn('EVR = ',HexWord(EVR));
  WriteLn('LC  = ',HexWord(LC));
  ReadKey;}
End; { Set160Rows }


Procedure Set160Rows1(Rows: Word);
Begin
  UnprotectCRTC;
  Asm

    { Change to 160 columns by changing the horizontal registers }

    MOV   DX,SC_INDEX

    MOV   AL,1
    OUT   DX,AL
    INC   DX
    IN    AL,DX
    OR    AL,8
    OUT   DX,AL

    MOV   DX,CRTC_INDEX

    MOV   AL,HORZ_TOTAL
    OUT   DX,AL
    INC   DX
    MOV   AL,2Ah
    OUT   DX,AL
    DEC   DX

    MOV   AL,HORZ_DISPLAY_END
    OUT   DX,AL
    INC   DX
    MOV   AL,27h
    OUT   DX,AL
    DEC   DX

    MOV   AL,START_HORZ_BLANK
    OUT   DX,AL
    INC   DX
    MOV   AL,28h
    OUT   DX,AL
    DEC   DX

    MOV   AL,END_HORZ_BLANK
    OUT   DX,AL
    INC   DX
    MOV   AL,8Eh
    OUT   DX,AL
    DEC   DX

    MOV   AL,START_HORZ_RETRACE
    OUT   DX,AL
    INC   DX
    MOV   AL,2Ch
    OUT   DX,AL
    DEC   DX

    MOV   AL,END_HORZ_RETRACE
    OUT   DX,AL
    INC   DX
    MOV   AL,8Eh
    OUT   DX,AL
    DEC   DX

    MOV   AL,CRTC_OFFSET
    OUT   DX,AL
    INC   DX
    MOV   AL,14h
    OUT   DX,AL
    DEC   DX

    { Change to new rows by changing the vertical registers }

    MOV   BX,WORD PTR Rows
    SUB   BX,200

    MOV   DX,CRTC_INDEX

    MOV   AL,MAX_SCAN_LINE
    OUT   DX,AL
    INC   DX
    IN    AL,DX
    MOV   CL,AL
    AND   CL,1Fh
    SHL   BL,CL
    DEC   DX

    MOV   BH,1Fh

    MOV   AL,VERT_TOTAL
    OUT   DX,AL
    INC   DX
    IN    AL,DX
    ADD   AL,BL
    JNC   @L1
    MOV   BH,02Eh
@L1:
    OUT   DX,AL
    DEC   DX

    MOV   AL,OVERFLOW
    OUT   DX,AL
    INC   DX
    MOV   AL,BH
{    OUT   DX,AL}
    DEC   DX

    MOV   AL,MAX_SCAN_LINE
    OUT   DX,AL
    INC   DX
    IN    AL,DX
{    MOV   CL,AL
    AND   CL,1Fh
    SHL   BX,CL}
    CMP   BH,1Fh
    JE    @L2
    OR    AL,40h
@L2:
    OUT   DX,AL
    DEC   DX
{
    MOV   AL,OVERFLOW
    OUT   DX,AL
    INC   DX
    MOV   AL,1Fh
    OUT   DX,AL
    DEC   DX

    MOV   AL,MAX_SCAN_LINE
    OUT   DX,AL
    INC   DX
    MOV   AL,41h
    OUT   DX,AL
    DEC   DX
}
    MOV   AL,START_VERT_RETRACE
    OUT   DX,AL
    INC   DX
    IN    AL,DX
    ADD   AL,BL
    OUT   DX,AL
    DEC   DX

    MOV   AL,END_VERT_RETRACE
    OUT   DX,AL
    INC   DX
    IN    AL,DX
    MOV   CL,AL
    ADD   CL,BL
    AND   CL,0Fh
    AND   AL,20h
    OR    AL,CL
    OUT   DX,AL
    DEC   DX

    MOV   AL,VERT_DISPLAY_END
    OUT   DX,AL
    INC   DX
    IN    AL,DX
    ADD   AL,BL
    OUT   DX,AL
    DEC   DX

    MOV   AL,START_VERT_BLANK
    OUT   DX,AL
    INC   DX
    IN    AL,DX
    ADD   AL,BL
    OUT   DX,AL
    DEC   DX

    MOV   AL,END_VERT_BLANK
    OUT   DX,AL
    INC   DX
    IN    AL,DX
    ADD   AL,BL
    OUT   DX,AL
    DEC   DX
  End; { Asm }
  ProtectCRTC;
End; { Set160Rows1 }


Procedure Set200Rows;
Begin
  UnprotectCRTC;
  Asm

    { Change to 205 rows by changing the vertical registers }

    MOV   DX,CRTC_INDEX

    MOV   AL,VERT_TOTAL
    OUT   DX,AL
    INC   DX
    MOV   AL,0BFh
    OUT   DX,AL
    DEC   DX

    MOV   AL,OVERFLOW
    OUT   DX,AL
    INC   DX
    MOV   AL,1Fh
    OUT   DX,AL
    DEC   DX

    MOV   AL,MAX_SCAN_LINE
    OUT   DX,AL
    INC   DX
    MOV   AL,41h
    OUT   DX,AL
    DEC   DX

    MOV   AL,START_VERT_RETRACE
    OUT   DX,AL
    INC   DX
    MOV   AL,09Ch
    OUT   DX,AL
    DEC   DX

    MOV   AL,END_VERT_RETRACE
    OUT   DX,AL
    INC   DX
    IN    AL,DX
    AND   AL,2Eh
    OR    AL,0Fh
    OUT   DX,AL
    DEC   DX

    MOV   AL,VERT_DISPLAY_END
    OUT   DX,AL
    INC   DX
    MOV   AL,08Fh
    OUT   DX,AL
    DEC   DX

    MOV   AL,START_VERT_BLANK
    OUT   DX,AL
    INC   DX
    MOV   AL,96h
    OUT   DX,AL
    DEC   DX

    MOV   AL,END_VERT_BLANK
    OUT   DX,AL
    INC   DX
    MOV   AL,0B9h
    OUT   DX,AL
    DEC   DX
  End; { Asm }
  ProtectCRTC;
End; { Set200Rows }


Procedure Set205Rows;
Begin
  UnprotectCRTC;
  Asm

    { Change to 205 rows by changing the vertical registers }

    MOV   DX,CRTC_INDEX

    MOV   AL,VERT_TOTAL
    OUT   DX,AL
    INC   DX
    MOV   AL,0C7h
    OUT   DX,AL
    DEC   DX

    MOV   AL,OVERFLOW
    OUT   DX,AL
    INC   DX
    MOV   AL,1Fh
    OUT   DX,AL
    DEC   DX

    MOV   AL,MAX_SCAN_LINE
    OUT   DX,AL
    INC   DX
    MOV   AL,41h
    OUT   DX,AL
    DEC   DX

    MOV   AL,START_VERT_RETRACE
    OUT   DX,AL
    INC   DX
    MOV   AL,0A4h
    OUT   DX,AL
    DEC   DX

    MOV   AL,END_VERT_RETRACE
    OUT   DX,AL
    INC   DX
    IN    AL,DX
    AND   AL,20h
    OR    AL,07h
    OUT   DX,AL
    DEC   DX

    MOV   AL,VERT_DISPLAY_END
    OUT   DX,AL
    INC   DX
    MOV   AL,097h
    OUT   DX,AL
    DEC   DX

    MOV   AL,START_VERT_BLANK
    OUT   DX,AL
    INC   DX
    MOV   AL,09Eh
    OUT   DX,AL
    DEC   DX

    MOV   AL,END_VERT_BLANK
    OUT   DX,AL
    INC   DX
    MOV   AL,0C1h
    OUT   DX,AL
    DEC   DX
  End; { Asm }
  ProtectCRTC;
End; { Set205Rows }


Procedure Set210Rows;
Begin
  UnprotectCRTC;
  Asm

    { Change to 210 rows by changing the vertical registers }

    MOV   DX,CRTC_INDEX

    MOV   AL,VERT_TOTAL
    OUT   DX,AL
    INC   DX
    MOV   AL,0D3h
    OUT   DX,AL
    DEC   DX

    MOV   AL,OVERFLOW
    OUT   DX,AL
    INC   DX
    MOV   AL,1Fh
    OUT   DX,AL
    DEC   DX

    MOV   AL,MAX_SCAN_LINE
    OUT   DX,AL
    INC   DX
    MOV   AL,41h
    OUT   DX,AL
    DEC   DX

    MOV   AL,START_VERT_RETRACE
    OUT   DX,AL
    INC   DX
    MOV   AL,0B0h
    OUT   DX,AL
    DEC   DX

    MOV   AL,END_VERT_RETRACE
    OUT   DX,AL
    INC   DX
    IN    AL,DX
    AND   AL,20h
    OR    AL,03h
    OUT   DX,AL
    DEC   DX

    MOV   AL,VERT_DISPLAY_END
    OUT   DX,AL
    INC   DX
    MOV   AL,0A3h
    OUT   DX,AL
    DEC   DX

    MOV   AL,START_VERT_BLANK
    OUT   DX,AL
    INC   DX
    MOV   AL,0AAh
    OUT   DX,AL
    DEC   DX

    MOV   AL,END_VERT_BLANK
    OUT   DX,AL
    INC   DX
    MOV   AL,0CDh
    OUT   DX,AL
    DEC   DX
  End; { Asm }
  ProtectCRTC;
End; { Set210Rows }


Procedure Set215Rows;
Begin
  UnprotectCRTC;
  Asm

    { Change to 215 rows by changing the vertical registers }

    MOV   DX,CRTC_INDEX

    MOV   AL,VERT_TOTAL
    OUT   DX,AL
    INC   DX
    MOV   AL,0D3h
    OUT   DX,AL
    DEC   DX

    MOV   AL,OVERFLOW
    OUT   DX,AL
    INC   DX
    MOV   AL,1Fh
    OUT   DX,AL
    DEC   DX

    MOV   AL,MAX_SCAN_LINE
    OUT   DX,AL
    INC   DX
    MOV   AL,41h
    OUT   DX,AL
    DEC   DX

    MOV   AL,START_VERT_RETRACE
    OUT   DX,AL
    INC   DX
    MOV   AL,0D0h
    OUT   DX,AL
    DEC   DX

    MOV   AL,END_VERT_RETRACE
    OUT   DX,AL
    INC   DX
    IN    AL,DX
    AND   AL,20h
    OR    AL,03h
    OUT   DX,AL
    DEC   DX

    MOV   AL,VERT_DISPLAY_END
    OUT   DX,AL
    INC   DX
    MOV   AL,0A3h
    OUT   DX,AL
    DEC   DX

    MOV   AL,START_VERT_BLANK
    OUT   DX,AL
    INC   DX
    MOV   AL,0AAh
    OUT   DX,AL
    DEC   DX

    MOV   AL,END_VERT_BLANK
    OUT   DX,AL
    INC   DX
    MOV   AL,0BDh
    OUT   DX,AL
    DEC   DX
  End; { Asm }
  ProtectCRTC;
End; { Set215Rows }


Procedure Set240Rows;
Begin
  UnprotectCRTC;
  Asm

    { Change to 240 rows by changing the vertical registers }

    MOV   DX,CRTC_INDEX

    MOV   AL,VERT_TOTAL
    OUT   DX,AL
    INC   DX
    MOV   AL,005h
    OUT   DX,AL
    DEC   DX

    MOV   AL,OVERFLOW
    OUT   DX,AL
    INC   DX
    MOV   AL,3Eh
    OUT   DX,AL
    DEC   DX

    MOV   AL,MAX_SCAN_LINE
    OUT   DX,AL
    INC   DX
    MOV   AL,41h
    OUT   DX,AL
    DEC   DX

    MOV   AL,START_VERT_RETRACE
    OUT   DX,AL
    INC   DX
    MOV   AL,0E2h
    OUT   DX,AL
    DEC   DX

    MOV   AL,END_VERT_RETRACE
    OUT   DX,AL
    INC   DX
    IN    AL,DX
    AND   AL,20h
    OR    AL,05h
    OUT   DX,AL
    DEC   DX

    MOV   AL,VERT_DISPLAY_END
    OUT   DX,AL
    INC   DX
    MOV   AL,0D5h
    OUT   DX,AL
    DEC   DX

    MOV   AL,START_VERT_BLANK
    OUT   DX,AL
    INC   DX
    MOV   AL,0DCh
    OUT   DX,AL
    DEC   DX

    MOV   AL,END_VERT_BLANK
    OUT   DX,AL
    INC   DX
    MOV   AL,0FFh
    OUT   DX,AL
    DEC   DX

    MOV   DX,MISC_OUTPUT
    MOV   AL,0E7h
    OUT   DX,AL
  End; { Asm }
  ProtectCRTC;
End; { Set240Rows }


Procedure PutChar(X,Y: Word; C: Char; Color: Word); Assembler;
Asm
  TEST  BYTE PTR HiRes,0FFh
  JZ    @Normal
  MOV   AX,WORD PTR Y
  SHL   AX,4
  MOV   DI,AX
  SHL   DI,2
  ADD   DI,AX
  MOV   AX,WORD PTR X
  SHR   AX,2
  ADD   DI,AX
  MOV   AH,11h
  MOV   CX,WORD PTR X
  AND   CX,3
  ROL   AH,CL
  MOV   AL,MAP_MASK
  MOV   DX,SC_INDEX

  PUSH  DS
  LDS   SI,DWORD PTR FontPtr
  MOV   BL,BYTE PTR C
  SUB   BH,BH
  SHL   BX,3
  ADD   SI,BX
  MOV   BX,0A000h
  MOV   ES,BX
  MOV   CX,8
  MOV   BX,WORD PTR Color
@Loop1:
  OUT   DX,AX

  TEST  BYTE PTR [SI],80h
  JNZ   @On0
  MOV   BYTE PTR [ES:DI],BH
  JMP   @Do4
@On0:
  MOV   BYTE PTR [ES:DI],BL
@Do4:
  TEST  BYTE PTR [SI],8
  JNZ   @On4
  MOV   BYTE PTR [ES:DI + 1],BH
  JMP   @Do1
@On4:
  MOV   BYTE PTR [ES:DI + 1],BL
@Do1:

  ROL   AH,1
  ADC   DI,0
  OUT   DX,AX
  TEST  BYTE PTR [SI],40h
  JNZ   @On1
  MOV   BYTE PTR [ES:DI],BH
  JMP   @Do5
@On1:
  MOV   BYTE PTR [ES:DI],BL
@Do5:
  TEST  BYTE PTR [SI],4
  JNZ   @On5
  MOV   BYTE PTR [ES:DI + 1],BH
  JMP   @Do2
@On5:
  MOV   BYTE PTR [ES:DI + 1],BL
@Do2:

  ROL   AH,1
  ADC   DI,0
  OUT   DX,AX
  TEST  BYTE PTR [SI],20h
  JNZ   @On2
  MOV   BYTE PTR [ES:DI],BH
  JMP   @Do6
@On2:
  MOV   BYTE PTR [ES:DI],BL
@Do6:
  TEST  BYTE PTR [SI],2
  JNZ   @On6
  MOV   BYTE PTR [ES:DI + 1],BH
  JMP   @Do3
@On6:
  MOV   BYTE PTR [ES:DI + 1],BL
@Do3:

  ROL   AH,1
  ADC   DI,0
  OUT   DX,AX
  TEST  BYTE PTR [SI],10h
  JNZ   @On3
  MOV   BYTE PTR [ES:DI],BH
  JMP   @Do7
@On3:
  MOV   BYTE PTR [ES:DI],BL
@Do7:
  TEST  BYTE PTR [SI],1
  JNZ   @On7
  MOV   BYTE PTR [ES:DI + 1],BH
  JMP   @Done
@On7:
  MOV   BYTE PTR [ES:DI + 1],BL
@Done:
  ROL   AH,1
  TEST  BYTE PTR X,3
  JZ    @NoDec
  DEC   DI
@NoDec:
  ADD   DI,80
  INC   SI
  DEC   CX
  JNZ   @Loop1

  POP   DS
  JMP   @L3

@Normal:
  MOV   AX,WORD PTR Y
  SUB   BX,BX
  MOV   BH,AL
  SHL   AX,6
  ADD   BX,AX
  MOV   DI,BX
  ADD   DI,WORD PTR X
  PUSH  DS
  LDS   SI,DWORD PTR FontPtr
  MOV   AL,BYTE PTR C
  SUB   AH,AH
  SHL   AX,3
  ADD   SI,AX
  MOV   AX,0A000h
  MOV   ES,AX
  MOV   AL,8
  ADD   DI,7
  MOV   DX,WORD PTR Color
@Loop:
  MOV   BH,BYTE PTR [SI]
  MOV   CX,8
  MOV   BL,1
@L1:
  TEST  BH,BL
  JZ    @L2
  MOV   BYTE PTR [ES:DI],DL
  DEC   DI
  ADD   BL,BL
  LOOP  @L1
  ADD   DI,328
  INC   SI
  DEC   AL
  JNZ   @Loop
  POP   DS
  JMP   @L3
@L2:
  MOV   BYTE PTR [ES:DI],DH
  DEC   DI
  ADD   BL,BL
  LOOP  @L1
  ADD   DI,328
  INC   SI
  DEC   AL
  JNZ   @Loop
  POP   DS
@L3:
End; { PutChar }


Procedure WriteOut(X,Y: Word; St: String; Color: Word);
Var I: Byte;
Begin
  If St = '' Then Exit;
  For I := 0 To Length(St) - 1 Do PutChar(X + (I * 8),Y,St[I + 1],Color);
End; { WriteOut }


Procedure PutSmChar(X,Y: Word; C: Char; Color: Word); Assembler;
Asm
  TEST  BYTE PTR HiRes,0FFh
  JZ    @Normal
  MOV   AX,WORD PTR Y
  SHL   AX,4
  MOV   DI,AX
  SHL   DI,2
  ADD   DI,AX
  MOV   AX,WORD PTR X
  SHR   AX,2
  ADD   DI,AX
  MOV   AH,11h
  MOV   CX,WORD PTR X
  AND   CX,3
  ROL   AH,CL
  MOV   AL,MAP_MASK
  MOV   DX,SC_INDEX

  PUSH  DS
  LDS   SI,DWORD PTR FontSmPtr
  MOV   BL,BYTE PTR C
  SUB   BH,BH
  SHL   BX,3
  ADD   SI,BX
  MOV   BX,0A000h
  MOV   ES,BX
  MOV   CX,8
  MOV   BX,WORD PTR Color
@Loop1:
  OUT   DX,AX

  TEST  BYTE PTR [SI],80h
  JNZ   @On0
  MOV   BYTE PTR [ES:DI],BH
  JMP   @Do4
@On0:
  MOV   BYTE PTR [ES:DI],BL
@Do4:
  TEST  BYTE PTR [SI],8
  JNZ   @On4
  MOV   BYTE PTR [ES:DI + 1],BH
  JMP   @Do1
@On4:
  MOV   BYTE PTR [ES:DI + 1],BL
@Do1:

  ROL   AH,1
  ADC   DI,0
  OUT   DX,AX
  TEST  BYTE PTR [SI],40h
  JNZ   @On1
  MOV   BYTE PTR [ES:DI],BH
  JMP   @Do5
@On1:
  MOV   BYTE PTR [ES:DI],BL
@Do5:
  TEST  BYTE PTR [SI],4
  JNZ   @On5
  MOV   BYTE PTR [ES:DI + 1],BH
  JMP   @Do2
@On5:
  MOV   BYTE PTR [ES:DI + 1],BL
@Do2:

  ROL   AH,1
  ADC   DI,0
  OUT   DX,AX
  TEST  BYTE PTR [SI],20h
  JNZ   @On2
  MOV   BYTE PTR [ES:DI],BH
  JMP   @Do3
@On2:
  MOV   BYTE PTR [ES:DI],BL
@Do3:
  ROL   AH,1
  ADC   DI,0
  OUT   DX,AX
  TEST  BYTE PTR [SI],10h
  JNZ   @On3
  MOV   BYTE PTR [ES:DI],BH
  JMP   @Done
@On3:
  MOV   BYTE PTR [ES:DI],BL
@Done:
  ROL   AH,1
  TEST  BYTE PTR X,3
  JZ    @NoDec
  DEC   DI
@NoDec:
  ADD   DI,80
  INC   SI
  DEC   CX
  JNZ   @Loop1

  POP   DS
  JMP   @L3

@Normal:
  MOV   AX,WORD PTR Y
  SUB   BX,BX
  MOV   BH,AL
  SHL   AX,6
  ADD   BX,AX
  MOV   DI,BX
  ADD   DI,WORD PTR X
  PUSH  DS
  LDS   SI,DWORD PTR FontSmPtr
  MOV   AL,BYTE PTR C
  SUB   AH,AH
  SHL   AX,3
  ADD   SI,AX
  MOV   AX,0A000h
  MOV   ES,AX
  MOV   AL,8
  ADD   DI,7
  MOV   DX,WORD PTR Color
@Loop:
  MOV   BH,BYTE PTR [SI]
  MOV   CX,6
  MOV   BL,4
@L1:
  TEST  BH,BL
  JZ    @L2
  MOV   BYTE PTR [ES:DI],DL
  DEC   DI
  ADD   BL,BL
  LOOP  @L1
  ADD   DI,326
  INC   SI
  DEC   AL
  JNZ   @Loop
  POP   DS
  JMP   @L3
@L2:
  MOV   BYTE PTR [ES:DI],DH
  DEC   DI
  ADD   BL,BL
  LOOP  @L1
  ADD   DI,326
  INC   SI
  DEC   AL
  JNZ   @Loop
  POP   DS
@L3:
End; { PutSmChar }


Procedure WriteSmOut(X,Y: Word; St: String; Color: Word);
Var I: Byte;
Begin
  If St = '' Then Exit;
  For I := 0 To Length(St) - 1 Do PutSmChar(X + (I * 6),Y,St[I + 1],Color);
End; { WriteSmOut }


Procedure Swap(Var A,B: Word);
Var C: Word;
Begin
  C := A;
  A := B;
  B := C;
End; { Swap }


Procedure SwapInt(Var A,B: Integer);
Var C: Integer;
Begin
  C := A;
  A := B;
  B := C;
End; { SwapInt }


Function __MakeWin(Var W: _WindowPtr; X1,Y1,X2,Y2: Word; Fill: Byte): Boolean;
Begin
  If W = Nil Then New(W);
  If X2 < X1 Then Swap(X1,X2);
  If Y2 < Y1 Then Swap(Y1,Y2);
  W^._X1        := X1;
  W^._Y1        := Y1;
  W^._X2        := X2;
  W^._Y2        := Y2;
  W^._Size      := (Y2 - Y1 + 1) * (X2 - X1 + 1);
  W^._Back      := Nil;
  W^._Active    := False;
  W^._FillColor := Fill;
  __MakeWin := True;
End; { __MakeWin }


Function __DispWin(Var W: _WindowPtr): Boolean;
Var
  I,J : Word;
  M   : Boolean;
  P   : Pointer;
  X,Y : Word;

Begin
  If W = Nil Then                           { __MakeWin has not been called }
  Begin
    __DispWin := False;
    Exit;
  End;
  If MaxAvail < W^._Size Then                  { Not enough heap space free }
  Begin
    __DispWin := False;
    Exit;
  End;
  GetMem(W^._Back,W^._Size);
  I := Seg(W^._Back^);
  J := Ofs(W^._Back^);
  If J > $F Then
  Begin
    Inc(I,J Shr 4);
    J := J And $F;
  End;
  P          := Ptr(I,J);
  W^._Active := True;
  J := W^._X2 - W^._X1 + 1;
{  M := MouseVisible;}
{  If M Then ToggleMouseVisibility;}
  For I := 0 To W^._Y2 - W^._Y1 Do
  Begin
    Move(Mem[$A000:(I + W^._Y1) * 320 + W^._X1],
         Mem[Seg(P^):Ofs(P^) + I * J],J);
    FillChar(Mem[$A000:(I + W^._Y1) * 320 + W^._X1],
             J,W^._FillColor);
  End; { For I }
{  If M Then ToggleMouseVisibility;}
  If _WindowList = Nil Then
  Begin
    New(_WindowList);
    _WindowList^._Prev   := Nil;
    _WindowList^._Next   := Nil;
    _WindowList^._Window := W;
  End
  Else
  Begin
    _ListWork := _WindowList;
    While _ListWork^._Next <> Nil Do _ListWork := _ListWork^._Next;
    New(_ListWork^._Next);
    _ListWork^._Next^._Prev := _ListWork;
    _ListWork               := _ListWork^._Next;
    _ListWork^._Next        := Nil;
    _ListWork^._Window      := W;
  End;
  __DispWin := True;
End; { __DispWin }


Function __RemWin: Boolean;
Var
  I,J : Word;
  W   : _WindowPtr;
  M   : Boolean;

Begin
  If _WindowList = Nil Then
  Begin
    __RemWin := False;
    Exit;
  End;
  _ListWork := _WindowList;
  While _ListWork^._Next <> Nil Do _ListWork := _ListWork^._Next;
  W := _ListWork^._Window;
  W^._Active := False;
  J := W^._X2 - W^._X1 + 1;
{  M := MouseVisible;}
{  If M Then ToggleMouseVisibility;}
  For I := 0 To W^._Y2 - W^._Y1 Do
  Begin
    Move(Mem[Seg(W^._Back^):Ofs(W^._Back^) + I * J],
         Mem[$A000:(I + W^._Y1) * 320 + W^._X1],J);
  End; { For I }
{  If M Then ToggleMouseVisibility;}
  FreeMem(W^._Back,W^._Size);
  If _ListWork^._Prev <> Nil Then
  Begin
    _ListWork := _ListWork^._Prev;
    Dispose(_ListWork^._Next);
    _ListWork^._Next := Nil;
  End
  Else
  Begin
    Dispose(_ListWork);
    _WindowList := Nil;
  End;
  __RemWin := True;
End; { __RemWin }


Procedure Box(X1,Y1,X2,Y2: Integer; Color: Byte);
Begin
  If HiRes Then RectangleX(X1,Y1,X2,Y2,0,Color)
  Else
  Begin
    Line(X1,Y1,X2,Y1,Color);
    Line(X2,Y1,X2,Y2,Color);
    Line(X2,Y2,X1,Y2,Color);
    Line(X1,Y2,X1,Y1,Color);
  End;
End; { Box }


Procedure FBox(X1,Y1,X2,Y2: Integer; Color: Byte);
Var Y,Addr,Len: Word;
Begin
  If HiRes Then FillRectangleX(X1,Y1,X2 + 1,Y2 + 1,0,Color)
  Else
  Begin
    If X2 < X1 Then SwapInt(X1,X2);
    If Y2 < Y1 Then SwapInt(Y1,Y2);
    Asm
      MOV   AX,WORD PTR Y1
      SUB   BX,BX
      MOV   BH,AL
      SHL   AX,6
      ADD   BX,AX
      MOV   DI,BX
      ADD   DI,WORD PTR X1
      MOV   WORD PTR Addr,DI
    End; { Asm }
    Len  := X2 - X1 + 1;
    For Y := Y1 To Y2 Do
    Begin
      FillChar(Mem[$A000:Addr],Len,Color);
      Inc(Addr,320);
    End; { For Y }
  End;
End; { FBox }


Function Debug(Buf: Pointer; Var PC: Word; Var P,A,X,Y,S: Byte; Scan,Count,Bank: Integer;
               ScnAddr: LongInt; Var NewStart: Word;{ Var OldByte: Byte;}
               BS: PBankSwitch; ROMBackup,TIA_Regs,Input_Byte,ObjectLoc: Pointer;
               Use160By200: Boolean; Var HaltLine: Integer): Boolean;
Const
  Timer_And : Array[$0..$1F] Of Byte =
   ($80,$81,$82,$83,$84,$85,$84,$85,$80,$81,$82,$83,$84,$85,$84,$85,
{    $94,$95,$96,$97,$94,$95,$96,$97,$94,$95,$96,$97,$94,$95,$96,$97);}
    $94,$95,$96,$97,$94,$95,$96,$97,$94,$95,$96,$97,$94,$95,$96,$97);

Var
  I,J,K   : Word;
  B       : Byte;
  DataTop : Word;
  Opcode  : Byte;
  Addr    : Word;
  OTyp    : String[3];
  Operand : String;
  Color   : Word;
  TopAddr : Word;
  Ch,Ch1  : Char;
  Access  : Word;
  AccSize : Word;
  Switch  : Boolean;
  Temp    : Boolean;
  _DLines : Word;
  St      : String;
  HaltNum : Integer;
  Code    : Integer;
  HexVal  : LongInt;
  HexAddr : LongInt;
  OutFile : File;

  Function TransWordWrite(Addr: Word): String;
  Begin
    If (Addr < $80) Or ((Addr >= $100) And (Addr < $180)) Then Addr := Addr And $3F;
    Case Addr Of
      0..$2C: TransWordWrite := TIA_Name[Addr];
{  $280..$297: TransWordWrite := PIA_Name[Addr];
  $380..$397: TransWordWrite := PIA_Name[Addr - $100];}
    $200..$3FF: TransWordWrite := PIA_Name[$200 Or Timer_And[Addr And $1F]];
    Else TransWordWrite := HexWord(Addr);
    End; { Case }
  End; { TransWordWrite }


  Function TransWordRead(Addr: Word): String;
  Begin
    Case Addr Of
      0..$7F,$100..$17F: TransWordRead := TIA_Read_Name[Addr And $F];
    $200..$3FF: TransWordRead := PIA_Name[$200 Or Timer_And[Addr And $1F]];
{  $280..$297: TransWordRead := PIA_Name[Addr];
  $380..$397: TransWordRead := PIA_Name[Addr - $100];}
     Else TransWordRead := HexWord(Addr);
     End; { Case }
  End; { TransWordRead }


  Function TransByteRead(Addr: Word): String;
  Begin
    Case Addr Of
      0..$7F,$100..$17F: TransByteRead := TIA_Read_Name[Addr And $F];
    $200..$3FF: TransByteRead := PIA_Name[$200 Or Timer_And[Addr And $1F]];
{  $280..$297: TransByteRead := PIA_Name[Addr];
  $380..$397: TransByteRead := PIA_Name[Addr - $100];}
     Else TransByteRead := HexByte(Addr);
     End; { Case }
  End; { TransByteRead }


  Function TransByteWrite(Addr: Word): String;
  Begin
    If (Addr < $80) Or ((Addr >= $100) And (Addr < $180)) Then Addr := Addr And $3F;
    Case Addr Of
      0..$2C: TransByteWrite := TIA_Name[Addr];
    Else TransByteWrite := HexByte(Addr);
    End; { Case }
  End; { TransByteWrite }


  Function TransWord(Addr: Word): String;
  Var Instr: String[3];
  Begin
    Instr := Mnem[Opcode];
    If (Addr < $80) And (Copy(Instr,1,2) = 'RO')
     Then TransWord := TransWordRead(Addr)
     Else
      If (Instr           = 'ADC') Or
         (Instr           = 'DEC') Or
         (Instr           = 'INC') Or
         (Instr           = 'SBC') Or
         (Copy(Instr,1,2) = 'PH')  Or
         (Copy(Instr,1,2) = 'RO')  Or
         (Copy(Instr,1,2) = 'ST')
       Then TransWord := TransWordWrite(Addr)
       Else TransWord := TransWordRead(Addr);
  End; { TransWord }


  Function TransByte(Addr: Word): String;
  Var Instr: String[3];
  Begin
    Instr := Mnem[Opcode];
    If (Addr < $80) And (Copy(Instr,1,2) = 'RO')
     Then TransByte := TransByteRead(Addr)
     Else
      If (Instr           = 'ADC') Or
         (Instr           = 'DEC') Or
         (Instr           = 'INC') Or
         (Instr           = 'SBC') Or
         (Copy(Instr,1,2) = 'PH')  Or
         (Copy(Instr,1,2) = 'RO')  Or
         (Copy(Instr,1,2) = 'ST')
       Then TransByte := TransByteWrite(Addr)
       Else TransByte := TransByteRead(Addr);
  End; { TransByte }


  Function IntToStr(L: LongInt): String;
  Var St: String;
  Begin
    Str(L,St);
    IntToStr := St;
  End; {IntToStr }

  Procedure FlipWindow;
  Var
    ThisWin   : Pointer;
    _ListWork : _ListPtr;
    W         : _WindowPtr;
    I,J       : Word;
    Pal       : Array[0..767] Of Byte;

  Begin
    If _WindowList = Nil Then Exit;
    Temp := HiRes;
    If HiRes Then Set320By200Mode;
    HiRes := False;
    _ListWork := _WindowList;
    While _ListWork^._Next <> Nil Do _ListWork := _ListWork^._Next;
    W := _ListWork^._Window;
    J := W^._X2 - W^._X1 + 1;
    For I := 0 To W^._Y2 - W^._Y1 Do
    Begin

      If Use160By200 Then Set160Cols;

      Move(Mem[Seg(W^._Back^):Ofs(W^._Back^) + I * J],
           Mem[$A000:(I + W^._Y1) * 320 + W^._X1],J);
    End; { For I }
    ReadKey;


    Port[$3C7] := 0;
    For I := 0 To 767 Do Pal[I] := Port[$3C9];

    If Use160By200 Then
    Begin
      Asm
        MOV   AX,13h
        INT   10h
      End; { Asm }
      Port[$3C8] := 0;
      For I := 0 To 767 Do Port[$3C9] := Pal[I];
    End;
    HiRes := Temp;
    If HiRes Then Set320By400Mode;
  End; { FlipWindow }


  Procedure Display;
  Var I,J: Integer;
  Begin
    If HiRes Then
    Begin
      FBox(0,0,319,399,BackColor);

      Box(0,0,250,259,LineColor);
      Box(252,0,319,19,LineColor);
      Box(252,21,319,72,LineColor);
      Box(0,333,319,399,LineColor);
      Box(252,74,319,125,LineColor);
      Box(0,261,319,287,LineColor);
      Box(0,289,319,299,LineColor);
      Box(0,301,319,311,LineColor);

      FBox(1,1,249,258,DisasmColor);
      FBox(253,1,318,18,FlagsColor);
      FBox(253,22,318,71,RegsColor);
      FBox(1,334,318,398,DataColor);
      FBox(253,75,318,124,ScrDatColor);
      FBox(1,262,318,286,TIA_Color);
      FBox(1,290,318,298,TIA_Color);
      FBox(1,302,318,310,DataColor + 1);

      WriteOut(254,2,'NV BDIZC' ,NormTextColor + (FlagsColor Shl 8));
      WriteOut(254,23,'PC=    h',NormTextColor + (RegsColor Shl 8));
      WriteOut(254,31,' P=  h  ',NormTextColor + (RegsColor Shl 8));
      WriteOut(254,39,' A=  h  ',NormTextColor + (RegsColor Shl 8));
      WriteOut(254,47,' X=  h  ',NormTextColor + (RegsColor Shl 8));
      WriteOut(254,55,' Y=  h  ',NormTextColor + (RegsColor Shl 8));
      WriteOut(254,63,' S=  h  ',NormTextColor + (RegsColor Shl 8));
      WriteSmOut(254, 76,'Scan=   ',NormTextColor + (ScrDatColor Shl 8));
      WriteSmOut(254, 84,'HPix=   ',NormTextColor + (ScrDatColor Shl 8));
      WriteSmOut(254, 92,'Bank=   ',NormTextColor + (ScrDatColor Shl 8));
      WriteSmOut(254,100,'Addr=   ',NormTextColor + (ScrDatColor Shl 8));
      WriteSmOut(254,108,'GRP0=   ',NormTextColor + (ScrDatColor Shl 8));
      WriteSmOut(254,116,'GRP1=   ',NormTextColor + (ScrDatColor Shl 8));
      WriteOut(254,127,'F1-Help',FlagsColor + (BackColor Shl 8));

      { Display flag data }

      For I := 0 To 7 Do
      Begin
        If (P And (1 Shl I)) <> 0
         Then WriteOut(310 - I * 8,10,'1',HiTextColor + (FlagsColor Shl 8))
         Else WriteOut(310 - I * 8,10,'0',HiTextColor + (FlagsColor Shl 8));
      End; { For I }

      { Display reg data }

      WriteOut(278,23,HexWord(PC),HiTextColor + (RegsColor Shl 8));
      WriteOut(278,31,HexByte(P) ,HiTextColor + (RegsColor Shl 8));
      WriteOut(278,39,HexByte(A) ,HiTextColor + (RegsColor Shl 8));
      WriteOut(278,47,HexByte(X) ,HiTextColor + (RegsColor Shl 8));
      WriteOut(278,55,HexByte(Y) ,HiTextColor + (RegsColor Shl 8));
      WriteOut(278,63,HexByte(S) ,HiTextColor + (RegsColor Shl 8));

      { Display screen info data }

      WriteOut(284, 76,IntToStr(Scan)  ,HiTextColor + (ScrDatColor Shl 8));
      WriteOut(284, 84,IntToStr(Count) ,HiTextColor + (ScrDatColor Shl 8));
      WriteOut(284, 92,IntToStr(Bank)  ,HiTextColor + (ScrDatColor Shl 8));
      WriteOut(284,100,HexWord(ScnAddr),HiTextColor + (ScrDatColor Shl 8));
      WriteOut(284,108,HexByte(Mem[Seg(TIA_Regs^):Ofs(TIA_Regs^) + GRP0]) + 'h',HiTextColor + (ScrDatColor Shl 8));
      WriteOut(284,116,HexByte(Mem[Seg(TIA_Regs^):Ofs(TIA_Regs^) + GRP1]) + 'h',HiTextColor + (ScrDatColor Shl 8));

      { Display data area }

      For I := 0 To DataLines - 1 Do
      Begin
        WriteOut(2,335 + I * 8,HexWord(DataTop + I * $10),NormTextColor + (DataColor Shl 8));
        For J := 0 To $F Do
        Begin
          WriteSmOut(44 + J * 17,335 + I * 8,
           HexByte(Mem[Seg(Buf^):Ofs(Buf^) + DataTop + I * $10 + J]),
           NormTextColor + (DataColor Shl 8));
          If (J And $F) = 7 Then
           DrawLineX(44 + J * 17 + 12,338 + I * 8,44 + J * 17 + 15,338 + I * 8,
            0,NormTextColor + (DataColor Shl 8));
        End; { For J }
      End; { For I }

      { Display TIA registers }

      For I := 0 To $2C Do
      Begin
        If (I And $F) = 0 Then
         WriteOut(2,263 + (I Shr 1),HexWord(I),NormTextColor + (TIA_Color Shl 8));
        WriteSmOut(44 + (I And $F) * 17,263 + ((I Shr 1) And $FFF8),
         HexByte(Mem[Seg(TIA_Regs^):Ofs(TIA_Regs^) + I]),
         NormTextColor + (TIA_Color Shl 8));
        If (I And $F) = 7 Then
         DrawLineX(44 + (I And $F) * 17 + 12,266 + ((I Shr 1) And $FFF8),
                   44 + (I And $F) * 17 + 15,266 + ((I Shr 1) And $FFF8),
          0,NormTextColor + (DataColor Shl 8));
      End; { For I }

      { Display input registers }

      For I := 0 To $F Do
      Begin
        If (I And $F) = 0 Then
         WriteOut(2,291 + (I Shr 1),HexWord(I),NormTextColor + (TIA_Color Shl 8));
        WriteSmOut(44 + (I And $F) * 17,291 + ((I Shr 1) And $FFF8),
         HexByte(Mem[Seg(Input_Byte^):Ofs(Input_Byte^) + I]),
         NormTextColor + (TIA_Color Shl 8));
        If (I And $F) = 7 Then
         DrawLineX(44 + (I And $F) * 17 + 12,294 + ((I Shr 1) And $FFF8),
                   44 + (I And $F) * 17 + 15,294 + ((I Shr 1) And $FFF8),
          0,NormTextColor + (DataColor Shl 8));
      End; { For I }

      { Display object locations }

      If Mem[Seg(Buf^):Ofs(Buf^) + GRP0] <> 0 Then
      Begin
        WriteOut(2,303,'P0',NormTextColor + (DataColor Shl 8));
        WriteSmOut(20,303,IntToStr(Integer(MemW[Seg(ObjectLoc^):Ofs(ObjectLoc^) + Player0Set * 2])),
         ScrDatColor + (DataColor Shl 8));
      End
      Else
      Begin
        WriteOut(2,303,'P0',NormTextColor + (DataColor Shl 8));
        WriteSmOut(20,303,IntToStr(Integer(MemW[Seg(ObjectLoc^):Ofs(ObjectLoc^) + Player0Set * 2])),
         NormTextColor + (DataColor Shl 8));
      End;

      If Mem[Seg(Buf^):Ofs(Buf^) + GRP1] <> 0 Then
      Begin
        WriteOut(44,303,'P1',NormTextColor + (DataColor Shl 8));
        WriteSmOut(62,303,IntToStr(Integer(MemW[Seg(ObjectLoc^):Ofs(ObjectLoc^) + Player1Set * 2])),
         ScrDatColor + (DataColor Shl 8));
      End
      Else
      Begin
        WriteOut(44,303,'P1',NormTextColor + (DataColor Shl 8));
        WriteSmOut(62,303,IntToStr(Integer(MemW[Seg(ObjectLoc^):Ofs(ObjectLoc^) + Player1Set * 2])),
         NormTextColor + (DataColor Shl 8));
      End;

      If (Mem[Seg(Buf^):Ofs(Buf^) + ENAM0] And 2) <> 0 Then
      Begin
        WriteOut(86,303,'M0',NormTextColor + (DataColor Shl 8));
        WriteSmOut(104,303,IntToStr(Integer(MemW[Seg(ObjectLoc^):Ofs(ObjectLoc^) + Missile0Set * 2])),
         ScrDatColor + (DataColor Shl 8));
      End
      Else
      Begin
        WriteOut(86,303,'M0',NormTextColor + (DataColor Shl 8));
        WriteSmOut(104,303,IntToStr(Integer(MemW[Seg(ObjectLoc^):Ofs(ObjectLoc^) + Missile0Set * 2])),
         NormTextColor + (DataColor Shl 8));
      End;

      If (Mem[Seg(Buf^):Ofs(Buf^) + ENAM1] And 2) <> 0 Then
      Begin
        WriteOut(128,303,'M1',NormTextColor + (DataColor Shl 8));
        WriteSmOut(146,303,IntToStr(Integer(MemW[Seg(ObjectLoc^):Ofs(ObjectLoc^) + Missile1Set * 2])),
         ScrDatColor + (DataColor Shl 8));
      End
      Else
      Begin
        WriteOut(128,303,'M1',NormTextColor + (DataColor Shl 8));
        WriteSmOut(146,303,IntToStr(Integer(MemW[Seg(ObjectLoc^):Ofs(ObjectLoc^) + Missile1Set * 2])),
         NormTextColor + (DataColor Shl 8));
      End;

      If (Mem[Seg(Buf^):Ofs(Buf^) + ENABL] And 2) <> 0 Then
      Begin
        WriteOut(170,303,'BL',NormTextColor + (DataColor Shl 8));
        WriteSmOut(188,303,IntToStr(Integer(MemW[Seg(ObjectLoc^):Ofs(ObjectLoc^) + BallSet * 2])),
         ScrDatColor + (DataColor Shl 8));
      End
      Else
      Begin
        WriteOut(170,303,'BL',NormTextColor + (DataColor Shl 8));
        WriteSmOut(188,303,IntToStr(Integer(MemW[Seg(ObjectLoc^):Ofs(ObjectLoc^) + BallSet * 2])),
         NormTextColor + (DataColor Shl 8));
      End;
    End
    Else
    Begin
      FBox(0,0,319,199,BackColor);
      Box(0,0,250,131,LineColor);
      Box(252,0,319,19,LineColor);
      Box(252,21,319,72,LineColor);
      Box(0,133,319,199,LineColor);
      Box(252,74,319,124,LineColor);
      FBox(1,1,249,130,DisasmColor);
      FBox(253,1,318,18,FlagsColor);
      FBox(253,22,318,71,RegsColor);
      FBox(1,134,318,198,DataColor);
      FBox(253,75,318,123,ScrDatColor);
      WriteOut(254,2,'NV BDIZC' ,NormTextColor + (FlagsColor Shl 8));
      WriteOut(254,23,'PC=    h',NormTextColor + (RegsColor Shl 8));
      WriteOut(254,31,' P=  h  ',NormTextColor + (RegsColor Shl 8));
      WriteOut(254,39,' A=  h  ',NormTextColor + (RegsColor Shl 8));
      WriteOut(254,47,' X=  h  ',NormTextColor + (RegsColor Shl 8));
      WriteOut(254,55,' Y=  h  ',NormTextColor + (RegsColor Shl 8));
      WriteOut(254,63,' S=  h  ',NormTextColor + (RegsColor Shl 8));
      WriteSmOut(254, 76,'Scan=   ',NormTextColor + (ScrDatColor Shl 8));
      WriteSmOut(254, 84,'HPix=   ',NormTextColor + (ScrDatColor Shl 8));
      WriteSmOut(254, 92,'Bank=   ',NormTextColor + (ScrDatColor Shl 8));
      WriteSmOut(254,100,'Addr=   ',NormTextColor + (ScrDatColor Shl 8));
      WriteSmOut(254,108,'GRP0=   ',NormTextColor + (ScrDatColor Shl 8));
      WriteSmOut(254,116,'GRP1=   ',NormTextColor + (ScrDatColor Shl 8));
      WriteOut(254,125,'F1-Help',FlagsColor + (BackColor Shl 8));

      { Display flag data }

      For I := 0 To 7 Do
      Begin
        If (P And (1 Shl I)) <> 0
         Then WriteOut(310 - I * 8,10,'1',HiTextColor + (FlagsColor Shl 8))
         Else WriteOut(310 - I * 8,10,'0',HiTextColor + (FlagsColor Shl 8));
      End; { For I }

      { Display reg data }

      WriteOut(278,23,HexWord(PC),HiTextColor + (RegsColor Shl 8));
      WriteOut(278,31,HexByte(P) ,HiTextColor + (RegsColor Shl 8));
      WriteOut(278,39,HexByte(A) ,HiTextColor + (RegsColor Shl 8));
      WriteOut(278,47,HexByte(X) ,HiTextColor + (RegsColor Shl 8));
      WriteOut(278,55,HexByte(Y) ,HiTextColor + (RegsColor Shl 8));
      WriteOut(278,63,HexByte(S) ,HiTextColor + (RegsColor Shl 8));

      { Display screen info data }

      WriteOut(284, 76,IntToStr(Scan)  ,HiTextColor + (ScrDatColor Shl 8));
      WriteOut(284, 84,IntToStr(Count) ,HiTextColor + (ScrDatColor Shl 8));
      WriteOut(284, 92,IntToStr(Bank)  ,HiTextColor + (ScrDatColor Shl 8));
      WriteOut(284,100,HexWord(ScnAddr),HiTextColor + (ScrDatColor Shl 8));
      WriteOut(284,108,HexByte(Mem[Seg(TIA_Regs^):Ofs(TIA_Regs^) + GRP0]) + 'h',HiTextColor + (ScrDatColor Shl 8));
      WriteOut(284,116,HexByte(Mem[Seg(TIA_Regs^):Ofs(TIA_Regs^) + GRP1]) + 'h',HiTextColor + (ScrDatColor Shl 8));

      { Display data area }

      For I := 0 To DataLines - 1 Do
      Begin
        WriteOut(2,135 + I * 8,HexWord(DataTop + I * $10),NormTextColor + (DataColor Shl 8));
        For J := 0 To $F Do
        Begin
          WriteSmOut(44 + J * 17,135 + I * 8,
           HexByte(Mem[Seg(Buf^):Ofs(Buf^) + DataTop + I * $10 + J]),
           NormTextColor + (DataColor Shl 8));
          If (J And $F) = 7 Then
           Line(44 + J * 17 + 14,138 + I * 8,44 + J * 17 + 17,138 + I * 8,
            NormTextColor + (DataColor Shl 8));
        End; { For J }
      End; { For I }
    End;
  End; { Display }


  Procedure GetImage(X1,Y1,X2,Y2: Word; Var P);
  Var X,Y,Addr,Dest: Word;
  Begin
    If HiRes Then
    Begin
      For Y := Y1 To Y2 Do
      Begin
        Addr := Y * 320 + X1;
        Dest := (Y - Y1) * (X2 - X1 + 1);
        For X := X1 To X2 Do
        Begin
          Port[$3CE] := 4;
          Port[$3CF] := Addr And 3;
          Mem[Seg(P):Ofs(P) + Dest + (X - X1)] := Mem[$A000:(Addr + X - X1) Shr 2];
        End; { For X }
      End; { For Y }
      Port[$3CE] := 4;
      Port[$3CF] := 0;
    End
    Else
    Begin
      For Y := Y1 To Y2 Do
      Begin
        Addr := Y * 320 + X1;
        Dest := (Y - Y1) * (X2 - X1 + 1);
        Move(Mem[$A000:Addr],Mem[Seg(P):Ofs(P) + Dest],X2 - X1 + 1);
      End; { For Y }
    End;
  End; { GetImage }


  Procedure PutImage(X1,Y1,W,H: Word; Var P);
  Var X,Y,Addr,Source: Word;
  Begin
    If HiRes Then CopySystemToScreenX(0,0,W,H,X1,Y1,@P,0,W,320)
    Else
    Begin
      For Y := Y1 To Y1 + H - 1 Do
      Begin
        Addr   := Y * 320 + X1;
        Source := (Y - Y1) * W;
        Move(Mem[Seg(P):Ofs(P) + Source],Mem[$A000:Addr],W);
      End; { For Y }
    End;
  End; { PutImage }


  Function GetText(X1,Y1,X2,Y2: Integer; InitString: String; Fore,Back: Byte; MaxLen,WindowLen: Integer): String;
  { ---------------------------------------------------------------------- }
  { Allows the user to type in a text string in graphics mode              }
  {    X1 ................. Upper left X coord of text input box           }
  {    Y1 ................. Upper left Y coord of text input box           }
  {    X2 ................. Lower right X coord of text input box          }
  {    Y2 ................. Lower right Y coord of text input box          }
  {    InitString ......... Initial text string                            }
  {    Fore ............... Text foreground color                          }
  {    Back ............... Text background color                          }
  {    MaxLen ............. Maximum string length                          }
  {    WindowLen .......... Displayed string length, for scrollable window }
  { ---------------------------------------------------------------------- }
  Const
    TextWidth  = 8;
    TextHeight = 8;

  Var
    Work  : String;
    Ch    : Char;
    Ch1   : Char;
    Top   : Integer;
    X     : Integer;
    Ins   : Boolean;
    TPtr  : Pointer;
    On    : Boolean;
    Pen   : Word;
    Brush : Word;

    Function ImageSize(X1,Y1,X2,Y2: Word): Word;
    Begin
      ImageSize := (X2 - X1 + 1) * (Y2 - Y1 + 1);
    End; { ImageSize }


    Function Max(A,B: Integer): Integer;
    Begin
      If A >= B Then Max := A Else Max := B;
    End; { Max }


    Function Min(A,B: Integer): Integer;
    Begin
      If A <= B Then Min := A Else Min := B;
    End; { Min }


    Procedure Cursor;
    { --------------------------------- }
    { Toggle to display/hide the cursor }
    { --------------------------------- }
    Begin
      If On Then
      Begin
        Pen   := Back;
        Brush := Back;
      End
      Else
      Begin
        Pen   := Fore;
        Brush := Fore;
      End;
      If Ins
       Then FBox(X1 + (X - Top)     * TextWidth + 1,Y1 + 4,
                 X1 + (X - Top + 1) * TextWidth,Y1 + TextHeight,Brush)
       Else FBox(X1 + (X - Top)     * TextWidth + 1,Y1 + TextHeight,
                 X1 + (X - Top + 1) * TextWidth,Y1 + TextHeight,Pen);
      On := Not On;
      If Not On Then
      Begin
        Pen   := Fore;
        Brush := Back;
        WriteOut(X1 + (X - Top) * TextWidth + 1,Y1 + 1,
         Copy(Work,X,1),Pen + (Brush Shl 8));
      End;
      Pen   := Fore;
      Brush := Fore;
    End; { Cursor }


    Procedure ScrollLeft;
    { --------------------------- }
    { Scroll the text window left }
    { --------------------------- }
    Var W,H: Word;
    Begin
      Inc(Top);
      GetMem(TPtr,ImageSize(X1 + TextWidth + 1,Y1,X2,Y2));
      GetImage(X1 + TextWidth + 1,Y1,X2,Y2,TPtr^);
      W     := X2 - (X1 + TextWidth + 1) + 1;
      H     := Y2 - Y1 + 1;
      Pen   := Back;
      Brush := Back;
      FBox(X1 + (WindowLen - 1) * TextWidth + 1,Y1,X2,Y2,Brush);
      Pen   := Fore;
      PutImage(X1 + 1,Y1,W,H,TPtr^);
      WriteOut(X1 + (WindowLen) * TextWidth + 1,Y1 + 1,
       Copy(Work,Top + WindowLen,1),Pen + (Brush Shl 8));
      FreeMem(TPtr,ImageSize(X1 + TextWidth + 1,Y1,X2,Y2));
    End; { ScrollLeft }


    Procedure ScrollRight;
    { ---------------------------- }
    { Scroll the text window right }
    { ---------------------------- }
    Var W,H: Word;
    Begin
      Dec(Top);
      GetMem(TPtr,ImageSize(X1 + TextWidth + 1,Y1,X2 + (WindowLen - 1) * TextWidth,Y2));
      GetImage(X1 + 1,Y1,X2 - TextWidth,Y2,TPtr^);
      W     := (X2 - TextWidth) - (X1 + 1) + 1;
      H     := Y2 - Y1 + 1;
      Pen   := Back;
      Brush := Back;
      FBox(X1,Y1,X1 + TextWidth,Y2,Brush);
      Pen   := Fore;
      PutImage(X1 + TextWidth + 1,Y1,W,H,TPtr^);
      WriteOut(X1 + 1,Y1 + 1,Copy(Work,Top,1),Pen + (Brush Shl 8));
      FreeMem(TPtr,ImageSize(X1 + TextWidth + 1,Y1,X2,Y2));
    End; { ScrollRight }

  Begin
    Work := '';
    Top  := 1;
    X    := 1;
    Ins  := False;
    On   := False;

    { Blank the window }

    Pen   := Back;
    Brush := Back;
    FBox(X1,Y1,X2,Y2,Brush);
    Pen   := Fore;

    Cursor;
    Ch := ' ';
    While Not (Ch In [#13,#27]) Do
    Begin
      If KeyPressed Then
      Begin
        Ch := ReadKey;
        Case Ch Of
     #13,#27: Begin
              End;
          #8: Begin                                   { Backspace }
                If X > 1 Then
                Begin
                  Cursor;
                  Delete(Work,X - 1,1);
                  If X > Top Then
                  Begin
                    Pen   := Back;
                    Brush := Back;
                    FBox(X1 + (X - Top - 1) * TextWidth + 1,Y1 + 1,X2 - 1,Y2 - 1,Brush);
                    Pen   := Fore;
                    WriteOut(X1 + (X - Top - 1) * TextWidth + 1,Y1 + 1,
                             Copy(Work,X - 1,WindowLen - (X - Top) + 1),Pen + (Brush Shl 8));
                  End;
                  Dec(X);
                  If X < Top Then ScrollRight;
                  Cursor;
                End;
              End;
          #0: Begin
                While Not KeyPressed Do Begin End;
                Ch1 := ReadKey;
                Case Ch1 Of
                  #71: If X > 1 Then                  { Home }
                       Begin
                         Cursor;
                         If Top <> 1 Then
                         Begin
                           Pen   := Back;
                           Brush := Back;
                           FBox(X1,Y1,X2,Y2,Brush);
                           Pen := Fore;
                           Top := 1;
                           WriteOut(X1 + 1,Y1 + 1,Copy(Work,1,WindowLen + 1),Pen + (Brush Shl 8));
                         End;
                         X := 1;
                         Cursor;
                       End;
                  #75: If X > 1 Then                  { Cursor Left }
                       Begin
                         Cursor;
                         Dec(X);
                         If X < Top Then ScrollRight;
                         Cursor;
                       End;
                  #77: If X <= Length(Work) Then      { Cursor Right }
                       Begin
                         Cursor;
                         Inc(X);
                         If X - Top = WindowLen Then ScrollLeft;
                         Cursor;
                       End;
                  #79: If X <= Length(Work) Then      { End }
                       Begin
                         Cursor;
                         If Top < Length(Work) - WindowLen + 2 Then
                         Begin
                           Pen   := Back;
                           Brush := Back;
                           FBox(X1,Y1,X2,Y2,Brush);
                           Pen   := Fore;
                           Top   := Length(Work) - WindowLen + 2;
                           WriteOut(X1 + 1,Y1 + 1,Copy(Work,Top,WindowLen),Pen + (Brush Shl 8));
                         End;
                         X := Length(Work) + 1;
                         Cursor;
                       End;
                  #82: Begin                          { Insert }
                         Cursor;
                         Ins := Not Ins;
                         Cursor;
                       End;
                  #83: Begin                          { Delete }
                         If ((Work <> '') And (X <= Length(Work))) Then
                         Begin
                           Cursor;
                           Delete(Work,X,1);
                           Pen   := Back;
                           Brush := Back;
                           FBox(X1 + (X - Top) * TextWidth + 1,Y1 + 1,X2 - 1,Y2 - 1,Brush);
                           Pen   := Fore;
                           WriteOut(X1 + (X - Top) * TextWidth + 1,Y1 + 1,
                            Copy(Work,X,WindowLen - (X - Top) + 1),Pen + (Brush Shl 8));
                           Cursor;
                         End;
                       End;
                End; { Case }
              End;
        Else
          Cursor;
          If (X > Length(Work)) Or Ins Then
          Begin
            If (Length(Work) < MaxLen) Then
            Begin
              Insert(Ch,Work,X);
              Pen   := Back;
              Brush := Back;
              FBox(X1 + (X - Top) * TextWidth + 1,Y1 + 1,X2 - 1,Y2 - 1,Brush);
              Pen   := Fore;
              WriteOut(X1 + (X - Top) * TextWidth + 1,Y1 + 1,
               Copy(Work,X,WindowLen - (X - Top) + 1),Pen + (Brush Shl 8));
            End;
          End
          Else
          Begin
            Work[X] := Ch;
            Pen   := Back;
            Brush := Back;
            FBox(X1 + (X - Top)     * TextWidth + 1,Y1 + 1,
                 X1 + (X - Top + 1) * TextWidth    ,Y2 - 1,Brush);
            Pen   := Fore;
            WriteOut(X1 + (X - Top) * TextWidth + 1,Y1 + 1,Copy(Work,X,1),Pen + (Brush Shl 8));
          End;
          If Not ((X > Length(Work)) And (Length(Work) = MaxLen)) Then
          Begin
            Inc(X);
             { Check to see if I must scroll the text left }
             If X - Top = WindowLen Then ScrollLeft;
          End;
          Cursor;
        End; { Case }
      End;
    End; { While }
    If Ch = #27 Then Work := InitString;
    Pen   := Back;
    Brush := Back;
    FBox(X1,Y1,X2,Y2,Brush);
    Pen   := Fore;
    WriteOut(X1 + 1,Y1 + 1,Copy(Work,1,WindowLen),Pen + (Brush Shl 8));
    GetText := Work;
  End; { GetText }

Begin
{  If MouseVisible Then ToggleMouseVisibility;}
  TopAddr := PC;
  DataTop := $80;
  __DispWin(Win);
  If HiRes Then Set320By400Mode;
  Display;
  Repeat

    { Display instructions }

{    If MouseVisible Then ToggleMouseVisibility;}
    Addr := TopAddr And $1FFF;
    If HiRes
     Then _DLines := HRDisasmLines
     Else _DLines := DisasmLines;
    For I := 0 To _DLines - 1 Do
    Begin
      If Addr = (PC And $1FFF) Then
      Begin
        Color := PCTextColor + (HiTextColor   Shl 8);
        FBox(2,2 + I * 8,248,9 + I * 8,HiTextColor);
      End
      Else
      Begin
        Color := NormTextColor + (DisasmColor Shl 8);
        FBox(2,2 + I * 8,248,9 + I * 8,DisasmColor);
      End;
      Opcode := Mem[Seg(Buf^):Ofs(Buf^) + Addr];

      If HiRes
       Then WriteSmOut(2,2 + I * 8,HexWord(Addr),Color)
       Else WriteOut(2,2 + I * 8,HexWord(Addr),Color);

      For J := 0 To Bytes[Opcode] - 1 Do
      Begin
        WriteSmOut(44 + J * 12,2 + I * 8,
         HexByte(Mem[Seg(Buf^):Ofs(Buf^) + Addr + J]),Color);
      End; { For J }

      If HiRes
       Then WriteSmOut(88,2 + I * 8,Mnem[Opcode],Color)
       Else WriteOut(88,2 + I * 8,Mnem[Opcode],Color);

      OTyp    := ATyp[Opcode];
      Operand := '';
      If OTyp = 'ABS' Then Operand := TransWord(MemW[Seg(Buf^):Ofs(Buf^) + Addr + 1] And $1FFF);
      If OTyp = 'A.X' Then Operand := TransWord(MemW[Seg(Buf^):Ofs(Buf^) + Addr + 1] And $1FFF) + ',X';
      If OTyp = 'A.Y' Then Operand := TransWord(MemW[Seg(Buf^):Ofs(Buf^) + Addr + 1] And $1FFF) + ',Y';
      If OTyp = 'ASY' Then Operand := '(' + TransWord(MemW[Seg(Buf^):Ofs(Buf^) + Addr + 1] And $1FFF) + ',Y) & S';
      If OTyp = 'IND' Then Operand := '(' + HexWord(MemW[Seg(Buf^):Ofs(Buf^) + Addr + 1] And $1FFF) + ')';
      If OTyp = 'I.X' Then Operand := '(' + HexByte(Mem[Seg(Buf^):Ofs(Buf^) + Addr + 1]) + ',X)';
      If OTyp = 'I.Y' Then Operand := '(' + HexByte(Mem[Seg(Buf^):Ofs(Buf^) + Addr + 1]) + '),Y';
      If OTyp = 'ACC' Then Operand := 'A';
      If OTyp = 'IMM' Then Operand := '#' + HexByte(Mem[Seg(Buf^):Ofs(Buf^) + Addr + 1]);
      If OTyp = 'Z.P' Then Operand := TransByte(Mem[Seg(Buf^):Ofs(Buf^) + Addr + 1]);
      If OTyp = 'Z.X' Then Operand := TransByte(Mem[Seg(Buf^):Ofs(Buf^) + Addr + 1]) + ',X';
      If OTyp = 'Z.Y' Then Operand := TransByte(Mem[Seg(Buf^):Ofs(Buf^) + Addr + 1]) + ',Y';
      If OTyp = 'I+A' Then Operand := '#' + HexByte(Mem[Seg(Buf^):Ofs(Buf^) + Addr + 1]) + ' + A';
      If OTyp = 'REL' Then
      Begin
        B := Mem[Seg(Buf^):Ofs(Buf^) + Addr + 1];
        Asm
          MOV   BX,WORD PTR Addr
          ADD   BX,2
          MOV   AL,BYTE PTR B
          CBW
          ADD   BX,AX
          MOV   WORD PTR J,BX
        End; { Asm }
        Operand := HexWord(J);
      End;

      If HiRes
       Then WriteSmOut(136,2 + I * 8,Operand,Color)
       Else WriteOut(136,2 + I * 8,Operand,Color);

      Inc(Addr,Bytes[Opcode]);
    End; { For I }
{    If Not MouseVisible Then ToggleMouseVisibility;}
    Ch := UpCase(ReadKey);
    If Ch = 'D' Then
    Begin
      HiRes := Not HiRes;
      If HiRes Then Set320By400Mode Else Set320By200Mode;
      Display;
    End;
    If Ch = 'S' Then
    Begin
      Opcode := Mem[Seg(Buf^):Ofs(Buf^) + PC];
      NewStart := PC + Bytes[Opcode];
{      OldByte  := Mem[Seg(Buf^):Ofs(Buf^) + NewStart];
      Mem[Seg(Buf^):Ofs(Buf^) + PC + Bytes[Opcode]] := BreakInstruction;}
    End;
    If Ch = 'H' Then
    Begin
      Opcode := Mem[Seg(Buf^):Ofs(Buf^) + TopAddr];
      NewStart := TopAddr;
{      OldByte  := Mem[Seg(Buf^):Ofs(Buf^) + NewStart];
      Mem[Seg(Buf^):Ofs(Buf^) + TopAddr] := BreakInstruction;}
    End;
    If Ch = 'G' Then NewStart := 0;
    If Ch = 'L' Then
    Begin
      GetMem(LineWinData,101 * 41);
      GetImage(110,80,210,120,LineWinData^);
      FBox(110,80,210,120,PopupColor);
      Box(110,80,210,120,ScrDatColor);
      WriteOut(112,82,'Scan line',NormTextColor + (PopupColor Shl 8));
      St := NoSpace(GetText(112,96,208,105,'',HiTextColor,TextBGColor,3,4));
      If St <> '' Then
      Begin
        Val(St,HaltNum,Code);
        If Code = 0 Then
        Begin
          HaltLine := HaltNum;
          NewStart := 0;
        End
        Else Ch := 'l';
      End
      Else Ch := 'l';  { Don't let it exit }
      PutImage(110,80,101,41,LineWinData^);
      FreeMem(LineWinData,101 * 41);
    End;
    If Ch = 'Z' Then
    Begin
      GetMem(LineWinData,101 * 41);
      GetImage(110,80,210,120,LineWinData^);
      FBox(110,80,210,120,PopupColor);
      Box(110,80,210,120,ScrDatColor);
      WriteOut(112,82,'Save to disk',NormTextColor + (PopupColor Shl 8));
      St := NoSpace(GetText(112,96,208,105,'',HiTextColor,TextBGColor,128,11));
      If St <> '' Then
      Begin
      {$I-}
        Assign(OutFile,St);
        ReWrite(OutFile,1);
      {$I+}
        If IOResult = 0 Then
        Begin
          BlockWrite(OutFile,Mem[Seg(Buf^):Ofs(Buf^) + $1000],$1000);
          Close(OutFile);
        End;
      End;
    End;
    If Ch = 'E' Then
    Begin
      GetMem(LineWinData,101 * 41);
      GetImage(110,80,210,120,LineWinData^);
      FBox(110,80,210,120,PopupColor);
      Box(110,80,210,120,ScrDatColor);
      WriteOut(112,82,'Enter data',NormTextColor + (PopupColor Shl 8));
      St   := ToUpper(NoSpace(GetText(112,96,208,105,'',HiTextColor,TextBGColor,80,11)));
      If St <> '' Then
      Begin
        Code := Pos('=',St);
        If Code <> 0 Then
        Begin
          HexAddr := ValHex(NoSpace(Copy(St,1,Code - 1)));
          If (HexAddr >= 0) And ((HexAddr And $1FFF) >= $80) Then
          Begin
            HexAddr := HexAddr And $1FFF;
            St   := NoSpace(Copy(St,Code + 1,Length(St) - Code));
            Code := Pos(' ',St);
            If (Code = 0) And (St <> '') Then Code := Length(St) + 1;
            While Code <> 0 Do
            Begin
              HexVal := ValHex(NoSpace(Copy(St,1,Code - 1)));
              If HexVal >= 0 Then Mem[Seg(Buf^):Ofs(Buf^) + HexAddr] := HexVal And $FF;
              Inc(HexAddr);
              St   := NoSpace(Copy(St,Code + 1,Length(St) - Code));
              Code := Pos(' ',St);
              If (Code = 0) And (St <> '') Then Code := Length(St) + 1;
            End; { While }
          End;
        End;
      End;
    End;
    If Ch = 'R' Then
    Begin
      GetMem(LineWinData,101 * 41);
      GetImage(110,80,210,120,LineWinData^);
      FBox(110,80,210,120,PopupColor);
      Box(110,80,210,120,ScrDatColor);
      WriteOut(112,82,'Change reg',NormTextColor + (PopupColor Shl 8));
      St   := ToUpper(NoSpace(GetText(112,96,208,105,'',HiTextColor,TextBGColor,7,8)));
      Code := Pos(' ',St);
      While Code <> 0 Do
      Begin
        Delete(St,Code,1);
        Code := Pos(' ',St);
      End; { While }
      If St <> '' Then
      Begin
        If Copy(St,1,3) = 'PC=' Then
        Begin
          HexVal := ValHex(Copy(St,4,Length(St) - 3));
          If HexVal >= 0 Then
          Begin
            PC := HexVal;{ And $1FFF;}
            Display;
          End;
        End;
        If Copy(St,1,2) = 'P=' Then
        Begin
          HexVal := ValHex(Copy(St,3,Length(St) - 2));
          If HexVal >= 0 Then
          Begin
            P := HexVal And $FF;
            Display;
          End;
        End;
        If Copy(St,1,2) = 'A=' Then
        Begin
          HexVal := ValHex(Copy(St,3,Length(St) - 2));
          If HexVal >= 0 Then
          Begin
            A := HexVal And $FF;
            Display;
          End;
        End;
        If Copy(St,1,2) = 'X=' Then
        Begin
          HexVal := ValHex(Copy(St,3,Length(St) - 2));
          If HexVal >= 0 Then
          Begin
            X := HexVal And $FF;
            Display;
          End;
        End;
        If Copy(St,1,2) = 'Y=' Then
        Begin
          HexVal := ValHex(Copy(St,3,Length(St) - 2));
          If HexVal >= 0 Then
          Begin
            Y := HexVal And $FF;
            Display;
          End;
        End;
        If Copy(St,1,2) = 'S=' Then
        Begin
          HexVal := ValHex(Copy(St,3,Length(St) - 2));
          If HexVal >= 0 Then
          Begin
            S := HexVal And $FF;
            Display;
          End;
        End;
      End;
      PutImage(110,80,101,41,LineWinData^);
      FreeMem(LineWinData,101 * 41);
    End;
    If Ch = 'T' Then
    Begin
      Opcode := Mem[Seg(Buf^):Ofs(Buf^) + PC];
      OTyp    := ATyp[Opcode];
      If Mnem[Opcode] = 'JSR' Then
      Begin
        NewStart := MemW[Seg(Buf^):Ofs(Buf^) + PC + 1] And $1FFF;
      End
      Else
       If Mnem[Opcode] = 'JMP' Then
       Begin
         If OTyp = 'ABS'
          Then NewStart := MemW[Seg(Buf^):Ofs(Buf^) + PC + 1] And $1FFF
          Else NewStart := MemW[Seg(Buf^):Ofs(Buf^) + MemW[Seg(Buf^):Ofs(Buf^) + PC + 1] And $1FFF] And $1FFF;
       End
       Else
        If Mnem[Opcode] = 'BPL' Then
        Begin
          If (P And $80) = 0
           Then NewStart := PC + ShortInt(Mem[Seg(Buf^):Ofs(Buf^) + PC + 1] + 2)
           Else NewStart := PC + Bytes[Opcode];
        End
        Else
         If Mnem[Opcode] = 'BMI' Then
         Begin
           If (P And $80) <> 0
            Then NewStart := PC + ShortInt(Mem[Seg(Buf^):Ofs(Buf^) + PC + 1] + 2)
            Else NewStart := PC + Bytes[Opcode];
         End
         Else
          If Mnem[Opcode] = 'BVC' Then
          Begin
            If (P And $40) = 0
             Then NewStart := PC + ShortInt(Mem[Seg(Buf^):Ofs(Buf^) + PC + 1] + 2)
             Else NewStart := PC + Bytes[Opcode];
          End
          Else
           If Mnem[Opcode] = 'BVS' Then
           Begin
             If (P And $40) <> 0
              Then NewStart := PC + ShortInt(Mem[Seg(Buf^):Ofs(Buf^) + PC + 1] + 2)
              Else NewStart := PC + Bytes[Opcode];
           End
           Else
            If Mnem[Opcode] = 'BCC' Then
            Begin
              If (P And 1) = 0
               Then NewStart := PC + ShortInt(Mem[Seg(Buf^):Ofs(Buf^) + PC + 1] + 2)
               Else NewStart := PC + Bytes[Opcode];
            End
            Else
             If Mnem[Opcode] = 'BCS' Then
             Begin
               If (P And 1) <> 0
                Then NewStart := PC + ShortInt(Mem[Seg(Buf^):Ofs(Buf^) + PC + 1] + 2)
                Else NewStart := PC + Bytes[Opcode];
             End
             Else
              If Mnem[Opcode] = 'BNE' Then
              Begin
                If (P And 2) = 0
                 Then NewStart := PC + ShortInt(Mem[Seg(Buf^):Ofs(Buf^) + PC + 1] + 2)
                 Else NewStart := PC + Bytes[Opcode];
              End
              Else
               If Mnem[Opcode] = 'BEQ' Then
               Begin
                 If (P And 2) <> 0
                  Then NewStart := PC + ShortInt(Mem[Seg(Buf^):Ofs(Buf^) + PC + 1] + 2)
                  Else NewStart := PC + Bytes[Opcode];
               End
               Else
                If Mnem[Opcode] = 'RTS' Then NewStart := (MemW[Seg(Buf^):Ofs(Buf^) + S + 1] + 1) And $1FFF
                Else
                 If Mnem[Opcode] = 'BRK' Then NewStart := MemW[Seg(Buf^):Ofs(Buf^) + $1FFE] And $1FFF
                 Else
                  If Mnem[Opcode] = 'RTI' Then NewStart := MemW[Seg(Buf^):Ofs(Buf^) + S + 2] And $1FFF
                  Else NewStart := PC + Bytes[Opcode];
(*
      { Check to see if the intervening instruction does any bank switching }

      AccSize := 1;
      Access  := 0;
      If OTyp = 'ABS' Then
      Begin
        If Mnem[Opcode] <> 'JSR'
         Then Access  := MemW[Seg(Buf^):Ofs(Buf^) + PC + 1]
         Else
         Begin
           Access  := S + $100 - 1;
           AccSize := 2;
         End;
      End
      Else
       If OTyp = 'A.X' Then Access  := MemW[Seg(Buf^):Ofs(Buf^) + PC + 1] + X
       Else
        If OTyp = 'A.Y' Then Access  := MemW[Seg(Buf^):Ofs(Buf^) + PC + 1] + Y
        Else
         If OTyp = 'Z.P' Then Access := Mem[Seg(Buf^):Ofs(Buf^) + PC + 1]
         Else
          If OTyp = 'Z.X' Then Access := Mem[Seg(Buf^):Ofs(Buf^) + PC + 1] + X
          Else
           If OTyp = 'IND' Then Access := MemW[Seg(Buf^):Ofs(Buf^) + MemW[Seg(Buf^):Ofs(Buf^) + PC + 1]]
           Else
            If OTyp = 'I.X' Then Access := MemW[Seg(Buf^):Ofs(Buf^) + MemW[Seg(Buf^):Ofs(Buf^) + PC + 1 + X]]
            Else
             If OTyp = 'I.Y' Then Access := MemW[Seg(Buf^):Ofs(Buf^) + MemW[Seg(Buf^):Ofs(Buf^) + PC + 1]] + Y
             Else
             Begin
               If Mnem[Opcode] = 'RTS' Then
               Begin
                 Access  := S + $101;
                 AccSize := 2;
               End
               Else
                If Copy(Mnem[Opcode],1,2) = 'PH' Then Access := S + $100
                Else
                 If Copy(Mnem[Opcode],1,2) = 'PL' Then Access := S + $101
                 Else
                  If Mnem[Opcode] = 'BRK' Then
                  Begin
                    Access  := S + $100 - 2;
                    AccSize := 3;
                  End
                  Else
                   If Mnem[Opcode] = 'RTI' Then
                   Begin
                     Access  := S + $100;
                     AccSize := 3;
                   End
                   Else
                   Begin
                     Access  := 0;
                     AccSize := 0;
                   End;
             End;
      Access := Access And $1FFF;
      Switch := False;
      While (AccSize > 0) And Not Switch Do
      Begin
        If Not (BS^[Access + AccSize - 1] In [0,$30])
         Then Switch := True
         Else Dec(AccSize);
      End; { While }
      If Switch Then
      Begin
        I := BS^[Access + AccSize - 1];
        Case I Of
   1..16: Begin

            WriteSmOut(0,0,'NewStart=' + HexWord(NewStart) + 'h',NormTextColor + (ScrDatColor Shl 8));
            WriteSmOut(0,8,'Dest=' + HexWord((I - 1) * 1024 + NewStart - $1000),NormTextColor + (ScrDatColor Shl 8));
            ReadKey;

            OldByte := Mem[Seg(ROMBackup^):Ofs(ROMBackup^) + (I - 1) * 1024 + NewStart - $1000];
            Mem[Seg(ROMBackup^):Ofs(ROMBackup^) + (I - 1) * 1024 + NewStart - $1000] := BreakInstruction;
          End;
   17,21: Begin
            OldByte := Mem[Seg(ROMBackup^):Ofs(ROMBackup^) + ((I Xor 4) - 17) * 1024 + NewStart - $1000];
            Mem[Seg(ROMBackup^):Ofs(ROMBackup^) + ((I Xor 4) - 17) * 1024 + NewStart - $1000] := BreakInstruction;
          End;
  33..41: Begin
            OldByte := Mem[Seg(ROMBackup^):Ofs(ROMBackup^) + (I - 33) * 1024 + NewStart - $1000];
            Mem[Seg(ROMBackup^):Ofs(ROMBackup^) + (I - 33) * 1024 + NewStart - $1000] := BreakInstruction;
          End;
$D0..$D7: Begin
            If NewStart < $1800 Then
            Begin
              I := I And 7;
              If I = 7 Then Inc(I);
              OldByte := Mem[Seg(ROMBackup^):Ofs(ROMBackup^) + I * 2048 + NewStart - $1000];
              Mem[Seg(ROMBackup^):Ofs(ROMBackup^) + I * 2048 + NewStart - $1000] := BreakInstruction;
            End;
          End;
$E0..$F7: Begin
            If (((I And $18) Shl 15) + $1000) = (NewStart And $1C00) Then
            Begin
              OldByte := Mem[Seg(ROMBackup^):Ofs(ROMBackup^) + (I And 7) * 1024 + NewStart - $1000];
              Mem[Seg(ROMBackup^):Ofs(ROMBackup^) + (I And 7) * 1024 + NewStart - $1000] := BreakInstruction;
            End;
          End;
        End; { Case }
      End
      Else
      Begin
        OldByte  := Mem[Seg(Buf^):Ofs(Buf^) + NewStart];
        Mem[Seg(Buf^):Ofs(Buf^) + NewStart] := BreakInstruction;
      End;
*)
    End;
    If Ch = ' ' Then
    Begin
      FlipWindow;
      Display;
    End;
    If Ch = #0 Then
    Begin
      Ch := ReadKey;
      Case Ch Of
        #59: Begin                         { F1 }
               Temp := HiRes;
               If HiRes Then Set320By200Mode;
               HiRes := False;
               __DispWin(HelpWin);
               Color := NormTextColor + (DataColor Shl 8);
               WriteOut(0,0,  'F1      - Help',Color);
               WriteOut(0,8,  'D       - Toggle 320x400 mode',Color);
               WriteOut(0,16, 'E       - Enter data at addr. (not TIA)',Color);
               WriteOut(0,24, 'G       - Begin execution of code',Color);
               WriteOut(0,32, 'H       - Execute to hilighted position',Color);
               WriteOut(0,40, 'L       - Execute until scan line',Color);
               WriteOut(0,48, 'R       - Change 6507 register',Color);
               WriteOut(0,56, 'S       - Execute over next instruction',Color);
               WriteOut(0,64, 'T       - Execute next instruction',Color);
               WriteOut(0,72, 'Z       - Save 4k ROM to disk',Color);
               WriteOut(0,80, '<Space> - Toggle game screen display',Color);

               WriteOut(0,120,'<Up>    - Move up one byte',Color);
               WriteOut(0,128,'<Down>  - Move down one instruction',Color);
               WriteOut(0,136,'<PgUp>  - Move up one screen',Color);
               WriteOut(0,144,'<PgDn>  - Move down one screen',Color);
               WriteOut(0,152,'<Home>  - Move to 1000h',Color);
               WriteOut(0,160,'<End>   - Move to 1FFFh',Color);
               WriteOut(0,168,'<Ins>   - Move to current instruction',Color);
               Color := ScrDatColor + (DataColor Shl 8);
               WriteOut(0,184,'Hit <Space> for more, or',Color);
               WriteOut(0,192,'any other key to return',Color);
               Ch1 := ReadKey;
               If Ch1 = #32 Then
               Begin
                 Color := NormTextColor + (DataColor Shl 8);
                 FillChar(Mem[$A000:0],64000,DataColor);
                 WriteOut(0,0,  ' 00   VSYNC         19   AUDV0',Color);
                 WriteOut(0,8,  ' 01   VBLANK        1A   AUDV1',Color);
                 WriteOut(0,16, ' 02   WSYNC         1B   GRP0',Color);
                 WriteOut(0,24, ' 03   RSYNC         1C   GRP1',Color);
                 WriteOut(0,32, ' 04   NUSIZ0        1D   ENAM0',Color);
                 WriteOut(0,40, ' 05   NUSIZ1        1E   ENAM1',Color);
                 WriteOut(0,48, ' 06   COLUP0        1F   ENABL',Color);
                 WriteOut(0,56, ' 07   COLUP1        20   HMP0',Color);
                 WriteOut(0,64, ' 08   COLUPF        21   HMP1',Color);
                 WriteOut(0,72, ' 09   COLUBK        22   HMM0',Color);
                 WriteOut(0,80, ' 0A   CTRLPF        23   HMM1',Color);
                 WriteOut(0,88, ' 0B   REFP0         24   HMBL',Color);
                 WriteOut(0,96, ' 0C   REFP1         25   VDELP0',Color);
                 WriteOut(0,104,' 0D   PF0           26   VDELP1',Color);
                 WriteOut(0,112,' 0E   PF1           27   VDELBL',Color);
                 WriteOut(0,120,' 0F   PF2           28   RESMP0',Color);
                 WriteOut(0,128,' 10   RESP0         29   RESMP1',Color);
                 WriteOut(0,136,' 11   RESP1         2A   HMOVE',Color);
                 WriteOut(0,144,' 12   RESM0         2B   HMCLR',Color);
                 WriteOut(0,152,' 13   RESM1         2C   CXCLR',Color);
                 WriteOut(0,160,' 14   RESBL',Color);
                 WriteOut(0,168,' 15   AUDC0',Color);
                 WriteOut(0,176,' 16   AUDC1',Color);
                 WriteOut(0,184,' 17   AUDF0',Color);
                 WriteOut(0,192,' 18   AUDF1',Color);
                 ReadKey;
               End;
               __RemWin;
               HiRes := Temp;
               If HiRes Then Set320By400Mode;
               Display;
             End;
        #71: TopAddr := $1000;             { Home }
        #72: Begin                         { Up }
               If TopAddr > 0 Then Dec(TopAddr);
             End;
        #73: Begin                         { PgUp }
               I := TopAddr;
               Repeat
                 J := 0;
                 K := I;
                 While K < TopAddr Do
                 Begin
                   Inc(J);
                   Opcode := Mem[Seg(Buf^):Ofs(Buf^) + K];
                   Inc(K,Bytes[Opcode]);
                 End; { While }
                 If J < _DLines - 1 Then Dec(I);
               Until J >= _Dlines - 1;
               TopAddr := I;
             End;
        #79: TopAddr := $1FFF;             { End }
        #80: Begin                         { Down }
               Opcode := Mem[Seg(Buf^):Ofs(Buf^) + TopAddr];
               Inc(TopAddr,Bytes[Opcode]);
             End;
        #81: TopAddr := Addr;              { PgDn }
        #82: TopAddr := PC;                { Insert }
      End; { Case }
      Ch := #0;
    End;
  Until Ch In [#27,'S','T','H','G','L'];

{  For I := 0 To 127 Do Line(I,198,I,199,I * 2);}
  While Keypressed Do ReadKey;
  If HiRes Then Set320By200Mode;
  __RemWin;
  Debug := (Ch In ['S','T','H','G','L']);
End; { Debug }


Begin
  Win         := Nil;
  HelpWin     := Nil;
  _WindowList := Nil;
  _ListWork   := Nil;
  OldExitProc := ExitProc;
  ExitProc    := @NewExitProc;
  GetMem(FontSmPtr,SmFontSize);
  LoadSmallFont;
  __MakeWin(Win,0,0,319,199,BackColor);
  __MakeWin(HelpWin,0,0,319,199,DataColor);
End.